<?php
namespace app\commands;

use yii\console\Controller;
use yii\helpers\ArrayHelper;
use Yii;
use app\components\SQLSiesa;
use ZipArchive;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of TracksalesController
 *
 * 
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 */
class TracksalesController extends Controller {
    
    private $sqlSiesa;
    private $nits;
    private $vendedores;
    private $fabricante;
    private $referencias;    
    private $serv_ftp;
    private $us_ftp;
    private $pass_ftp;
    private $directorio;
    private $archivoZip;

    const AR_VENTAS = 'Ventas';
    const AR_MUNICIPIOS = 'Municipios';
    const AR_SKU = 'SKU';
    const AR_TIPOS_NEGOCIO = 'Tipos de Negocio';
    const AR_VENDEDORES = 'Vendedores';
    const AR_SUPERVISORES = 'Supervisores';
    const AR_CLIENTES = 'Clientes';
    const AR_INVENTARIO = 'Inventario';
    const AR_TOTALES_CONTROL = 'Totales de Control';
    const AR_EXT = '.txt';
    const NM_FILE_ZIP = 'NEWELL_209599_';
    
    
    /**
     * Constructor de la clase
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function init() {
        $this->sqlSiesa = new SQLSiesa;        
        $this->fabricante = ['RUBBERMAID'];     
        $this->serv_ftp = 'apps.grupobit.net';        
        $this->us_ftp = 'Sanford_209599';
        $this->pass_ftp = 'San099';
        $this->directorio = $this->_getFolder();        
    }
	
	/**
     * Metodo de inicio
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function actionConsolidadoMes(){                 
            $this->_getConsolidadoMes();
    }

    /**
     * Metodo de inicio
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function actionIndex(){                 
        //Si es Lunes creamos el consolidado semanal
        $this->_getConsolidadoDiario();            
        //Si es fin de mes creamos el consolidado mensual
        if(date('d') == 1){
            $this->_getConsolidadoMes();
        }           
    }
    
    /**
     * Crea el consolidade del mes 
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getConsolidadoMes(){               
        //Creamos las fechas ---------------------------------------------------
        $this->sqlSiesa->fechaEn = date('d-m-Y');
        $this->sqlSiesa->fechaFn = date('d-m-Y', mktime(0, 0, 0, date('m')-0, 0, date('Y')));                
        $this->sqlSiesa->fechaIn = date('d-m-Y', mktime(0, 0, 0, date('m')-1, 1, date('Y')));                 
        //Damo nombre al archivo Zip -------------------------------------------     
        $fecha = explode('-', $this->sqlSiesa->fechaFn);
        $this->archivoZip = self::NM_FILE_ZIP.$fecha[2].'6'.$fecha[1].$fecha[0].'.zip';              
        //Creamos archivos -----------------------------------------------------                            
        $this->_getMunicipios();
        $this->_getSKU();
        $this->_getTiposNegocio();        
        $this->_getSupervisores();                   
        //Enviamos el archivo por FTP ------------------------------------------
        $this->_sendFileFTP();
    }
    
    /**
     * Crea el consolidade de la semana
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getConsolidadoDiario(){
        //Creamos las fechas ---------------------------------------------------
		//$this->sqlSiesa->fechaEn = '31-05-2023'; //FECHA FINAL
        //$this->sqlSiesa->fechaFn = '31-05-2023'; //FECHA FINAL
        //$this->sqlSiesa->fechaIn = '01-01-2023';//FECHA INICIAL
        $this->sqlSiesa->fechaEn = date('d-m-Y');
        $this->sqlSiesa->fechaFn = date('d-m-Y', mktime(0, 0, 0, date('m'), date('d')-1, date('Y')));                
        $this->sqlSiesa->fechaIn = date('d-m-Y', mktime(0, 0, 0, date('m'), 1, date('Y')));                                                                
        //Damo nombre al archivo Zip -------------------------------------------       
        //$this->archivoZip = self::NM_FILE_ZIP.date('Ymd').'.zip';      
        $this->archivoZip = self::NM_FILE_ZIP.date('Y').'6'.date('md').'.zip';        
        //Creamos archivos -----------------------------------------------------                            
        $this->_getMunicipios();
        $this->_getSKU();
        $this->_getTiposNegocio();        
        $this->_getSupervisores();                   
        //Enviamos el archivo por FTP ------------------------------------------
        $this->_sendFileFTP();
    }
    
    /**
     * Retorna el directorio donde seran almacenados los archivos 
     * 
     * @return string
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getFolder(){
        $basePath = Yii::getAlias('@app');
        $directorio = $basePath . DIRECTORY_SEPARATOR.'filesTrackSales';          
        if (!file_exists($directorio)) {            
            mkdir($directorio); 
        }
        return $directorio;
    }              
    
    /**
     * Metodo para crear el archivo con los municipios
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getMunicipios(){                            
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_MUNICIPIOS.self::AR_EXT;        
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $municipios = $this->sqlSiesa->getCiudades();
        if(count($municipios)>0){
            foreach ($municipios as $value) {                  
                $txt = $value['id']."{".$value['nombre']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para consultar los productos (SKU) y las referencias 
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getSKU(){        
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_SKU.self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $sku = $this->sqlSiesa->getItemsXFrabricante($this->fabricante); 
        //Extraemos las referencias del fabricacnte ----------------------------
        $this->referencias = ArrayHelper::map($sku, 'codigo_producto', 'codigo_producto');        
        //\Yii::error( __FILE__ . ':' . __LINE__. '{'.print_r($sku, true) . '}', 'tracksales');
        if(count($sku)>0){
            foreach ($sku as $value) {                  
                $txt = date('dmY')
                        ."{".$value['codigo_producto']
                        ."{".$value['nombre']
                        ."{".$value['unidad_medida']
                        ."{".$value['compania']//Codigo de barras por defecto el nit del proveedor
                        ."{".$value['compania']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
        //Requeire las referencias para consultar el inventario ----------------
        $this->_getInventario();
        //Rquiere las referencias para consultar las ventas --------------------
        $this->_getVentas();        
    }          
    
    /**
     * Metodo para crear el archivo con los tipos de negocio
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getTiposNegocio(){                            
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_TIPOS_NEGOCIO
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $tiposNegocio = $this->sqlSiesa->getTiposNegocio();
        if(count($tiposNegocio)>0){
            foreach ($tiposNegocio as $value) {                  
                $txt = $value['codigo']."{".$value['nombre']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para crear el archivo con los tipos de negocio
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVendedores(){                           
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_VENDEDORES
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------        
        $vendedores = $this->sqlSiesa->getVendedores($this->vendedores);
        if(count($vendedores)>0){
            foreach ($vendedores as $value) {                  
                $txt = $value['codigo']
                        ."{".$value['nombre']
                        ."{".$value['identificacion']
                        ."{".$value['codigo_supervisor']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para crear el archivo con el listado de supervisores
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getSupervisores(){                             
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_SUPERVISORES
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $supervisores = $this->sqlSiesa->getSupervisores();
        if(count($supervisores)>0){
            foreach ($supervisores as $value) {                  
                $txt = $value['codigo']."{".$value['nombre']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para crear el archivo con los clientes
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getClientes(){                            
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_CLIENTES
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------        
        $clientes = $this->sqlSiesa->getClientes($this->nits);
        //\Yii::error( __FILE__ . ':' . __LINE__. '{'.print_r($sku, true) . '}', 'tracksales');
        if(count($clientes)>0){
            foreach ($clientes as $value) {                  
                $txt = $value['codigo']
                        ."{".$value['nombre']
                        ."{".$value['fecha_ingreso']
                        ."{".$value['nit']
                        ."{".$value['direccion']
                        ."{".$value['codigo_municipio']
                        ."{".$value['id_tipo_negocio']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para crear el archivo con el inventario actual, el invetario
     * esta diferido por bodega
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getInventario(){                           
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_INVENTARIO
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $inventario = $this->sqlSiesa->getInventario($this->referencias);  
        
        if(count($inventario)>0){
            foreach ($inventario as $value) {                  
                $txt = date('dmY')
                        ."{".$value['codigo_producto']
                        ."{".(int)$value['cantidad']
                        ."{".$value['unidad_medida']
                        ."{".$value['co']."\n";
                fwrite($archivo, $txt);
            }
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);             
    }
    
    
    
        
    /**
     * Metodo para crear el archivo con el listado de supervisores
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVentas(){        
        $totalVentas = 0;
        $arrayClientes = [];          
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_VENTAS
                .self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $ventas = $this->sqlSiesa->getVentas($this->referencias);
        $this->nits = ArrayHelper::map($ventas, 'nit', 'nit');        
        $this->vendedores = ArrayHelper::map($ventas, 'codigo_vendedor', 'codigo_vendedor');        
        if(count($ventas)>0){
            foreach ($ventas as $value) { 
                $totalVentas = $totalVentas + $value['total_item_vendido'];
                $arrayClientes[] = $value['codigo_cliente'];
                $txt = $value['codigo_cliente']
                        ."{".$value['codigo_vendedor']
                        ."{".$value['codigo_producto']
                        ."{".str_replace('-', '', $value['fecha'])
                        ."{".$value['numero_documento']
                        //."{".number_format($value['cantidad'],3)
                        ."{".(int)$value['cantidad']
                        //."{".number_format($value['total_item_vendido'], 3)
                        ."{".(int)$value['total_item_vendido']
                        ."{".$value['tipo']
                        ."{".(int)$value['costo']
                        ."{".$value['unidad_medida']
                        ."{".$value['numero_pedido']
                        ."{".$value['co']."\n";
                fwrite($archivo, $txt);
            }            
            //Creamos los clientes ---------------------------------------------
            $this->_getClientes();
            //Creamos los vendedores -------------------------------------------
            $this->_getVendedores();
        }        
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
        //Requiere la consulta de ventas para extraer los clientes -------------
        $this->_getTotalesControl($totalVentas);
    }
    
    /**
     * Crea el archivo con el total de ventas
     * 
     * @param int $totalVentas Total de las ventas 
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getTotalesControl($totalVentas){          
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_TOTALES_CONTROL.  self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");        
        $txt = "TotalValorVenta{".$totalVentas."\n";
        fwrite($archivo, $txt);            
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }    
    
    /**
     * Metodo para crear el archivo comprimido 
     * 
     * @param string $directorio    Directorio del archivo
     * @param string $nombreArchivo Nombre del archivo
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _crearZip($directorio, $nombreArchivo){
        try {
            //Eliminamos los Zip anteriores ------------------------------------
//            $mask = "*.jpg";
//            array_map( "unlink", glob( $mask ) );
            //------------------------------------------------------------------
            $zip = new ZipArchive();
            //$zip->open($nombreArchivo,ZipArchive::CREATE);
            $zip->open($this->directorio.DIRECTORY_SEPARATOR
                        .$nombreArchivo,ZipArchive::CREATE);
            //Adjuntamos los archivos ------------------------------------------
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_VENTAS.self::AR_EXT,self::AR_VENTAS.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_MUNICIPIOS.self::AR_EXT,self::AR_MUNICIPIOS.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_SKU.self::AR_EXT,self::AR_SKU.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_TIPOS_NEGOCIO.self::AR_EXT,self::AR_TIPOS_NEGOCIO.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_VENDEDORES.self::AR_EXT,self::AR_VENDEDORES.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_SUPERVISORES.self::AR_EXT,self::AR_SUPERVISORES.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_CLIENTES.self::AR_EXT,self::AR_CLIENTES.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_INVENTARIO.self::AR_EXT,self::AR_INVENTARIO.self::AR_EXT);                      
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_TOTALES_CONTROL.self::AR_EXT,self::AR_TOTALES_CONTROL.self::AR_EXT);        
            $zip->close();
        } catch (\Exception $exc) {           
            \Yii::error( __FILE__ . ':' . __LINE__. '{' 
                    . $exc->getTraceAsString() . '}', 'tracksales');
        }        
    }
    
    /**
     * Metodo para enviar el archivo por FTP
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _sendFileFTP(){  
        try {                                          
            $this->_crearZip($this->directorio, $this->archivoZip);
            //----------------------------------------------------------------------
            $file = $this->directorio.DIRECTORY_SEPARATOR
                        .$this->archivoZip;            
            $remote_file = $fileFtp =  '/'.$this->archivoZip;             
            // establecer una conexión básica
            $conn_id = ftp_connect($this->serv_ftp);                
            // iniciar sesión con nombre de usuario y contraseña
            ftp_login($conn_id, $this->us_ftp, $this->pass_ftp);        
            ftp_pasv($conn_id, true);
            // cargar un archivo
            if (ftp_put($conn_id, $remote_file, $file, FTP_BINARY)) {                           
                \Yii::error( __FILE__ . ':' . __LINE__. '{ Transferencia con exito (' 
                    . $file . ')}', 'tracksales');
            } else {                
                \Yii::error( __FILE__ . ':' . __LINE__. '{ Error al transferir (' 
                    . $file . ')}', 'tracksales');
            }
            // cerrar la conexión ftp-----------------------------------------------
            ftp_close($conn_id);
        } catch (\Exception $exc) {           
            \Yii::error( __FILE__ . ':' . __LINE__. '{' 
                    . $exc->getMessage() . '}', 'tracksales');
        }                
    }
}
