<?php
namespace app\commands;

use yii\console\Controller;
use yii\helpers\ArrayHelper;
use Yii;
use app\components\SQLSiesa;
use ZipArchive;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of TracksalesController
 *
 * 
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 */
class UnileverController extends Controller {
    
    private $sqlSiesa;
    private $nits;
    private $vendedores;
    private $fabricante;
    private $referencias;    
    private $serv_ftp;
    private $us_ftp;
    private $pass_ftp;
    private $directorio;
    private $archivoZip;
    private $nitJDH;
    private $nitUnilever;
    private $date;
    private $fechaIn;
    private $fechaFn;
    private $fechaEn;

    const AR_VENTAS = 'ACC_SELLOUT_';
    const AR_MUNICIPIOS = 'Municipios';
    const AR_SKU = 'ACC_CADPROD_';
    const AR_TIPOS_NEGOCIO = 'Tipos de Negocio';
    const AR_VENDEDORES = 'Vendedores';
    const AR_SUPERVISORES = 'Supervisores';
    const AR_CLIENTES = 'ACC_PDVS_';
    const AR_INVENTARIO = 'ACC_POSESTQ_';
    const AR_TIENDAS = 'ACC_CADSITE_';
    const AR_EXT = '.txt';
    const NM_FILE_ZIP = 'JDH_';
    const DEFAULT_FIELD = 'NI';
    const FIELD_NO_REQ = '';
        
    
    /**
     * Constructor de la clase
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function init() {
        $this->sqlSiesa = new SQLSiesa;        
        $this->fabricante = ['UNILEVER ANDINA S.A.'];     
        $this->serv_ftp = 'integracoes.accera.com.br';        
        $this->us_ftp = 'dsi_juanhoyos_dist';
        $this->pass_ftp = 'lqfiisdg5udpzo2d';
        $this->directorio = $this->_getFolder();  
        $this->nitJDH = '811006789';        
        $this->nitUnilever = '860002518';        
        $this->date = date('Ymd');
    }
	
	public function actionConsolidadoMes(){                 
            $this->_getConsolidadoMes();
    } 

    /**
     * Metodo de inicio
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function actionIndex(){                 
        //Si es Lunes creamos el consolidado diario
        $this->_getConsolidadoDiario();  
		//Si es fin de mes creamos el consolidado mensual
        if(date('d') == 1){
            $this->_getConsolidadoMes();
        }
    }        
    
    /**
     * Crea el consolidade de la semana
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getConsolidadoDiario(){
        //Creamos las fechas ---------------------------------------------------
		
		$this->fechaEn = date('d-m-Y');
        $this->fechaFn = date('d-m-Y');
        $this->fechaIn = date('d-m-Y', mktime(0, 0, 0, date('m'), date('d')-1, date('Y')));
        //Damo nombre al archivo Zip -------------------------------------------       
        $this->archivoZip = self::NM_FILE_ZIP.date('Y').'6'.date('md').'.zip'; 
        //Creamos archivos -----------------------------------------------------                                    
        $this->_getProductos();                              
        //Enviamos el archivo por FTP ------------------------------------------
        $this->_sendFileFTP();
    }

	/**
     * Crea el consolidade del mes
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getConsolidadoMes(){
        //Creamos las fechas ---------------------------------------------------
		//$this->fechaEn = '28-02-2021';
        //$this->fechaFn = '28-02-2021';
        //$this->fechaIn = '01-02-2021';
		$this->fechaEn = date('d-m-Y');
        $this->fechaFn = date('d-m-Y', mktime(0, 0, 0, date('m')-0, 0, date('Y')));                
        $this->fechaIn = date('d-m-Y', mktime(0, 0, 0, date('m')-1, 1, date('Y')));
        //Damo nombre al archivo Zip ------------------------------------------- 
		$fecha = explode('-', $this->fechaFn);
        $this->archivoZip = self::NM_FILE_ZIP.$fecha[2].'6'.$fecha[1].$fecha[0].'.zip';
        //Creamos archivos -----------------------------------------------------                                    
        $this->_getProductos();                              
        //Enviamos el archivo por FTP ------------------------------------------
        $this->_sendFileFTP();
    }
    
    /**
     * Retorna el directorio donde seran almacenados los archivos 
     * 
     * @return string
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getFolder(){
        $basePath = Yii::getAlias('@app');
        $directorio = $basePath . DIRECTORY_SEPARATOR.'filesUnilever';          
        if (!file_exists($directorio)) {            
            mkdir($directorio); 
        }
        return $directorio;
    }                      
    
    /**
     * Metodo para consultar los productos (SKU) y las referencias 
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getProductos(){        
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_SKU.date('Ymd').self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $sku = $this->_ItemsXFrabricanteSiesa($this->fabricante);         
        //Extraemos las referencias del fabricacnte ----------------------------
        $this->referencias = ArrayHelper::map($sku, 'codigo_producto', 'codigo_barras');          
        if(count($sku)>0){
            $txt = 'H;'.$this->nitJDH.';'.date('Ymd')."\n";
            fwrite($archivo, $txt);
            foreach ($sku as $value) { 
                $fechaRegistro = trim($value['fecha_registro']);
                if($fechaRegistro == '18991230'){
                    $fechaRegistro = '20180101';
                }
                $txt = 'V;' //Tipo de registro
                        .$this->nitUnilever.';' //Codigo proveedor
                        .$this->fabricante[0].';' //Descripcion proveedor
                        .trim($value['codigo_producto']).';' //Codigo producto
                        .trim($value['descripcion']).';' //Descripcion producto
                        .trim($value['grupo_id']).';' //codigo grupo 
                        .trim($value['grupo']).';' //grupo
                        .self::FIELD_NO_REQ.';' //Codigo familia
                        .self::FIELD_NO_REQ.';' //Descripcion familia
                        .self::FIELD_NO_REQ.';' //Codigo subfamilia
                        .self::FIELD_NO_REQ.';' //Descripcion subfamilia
                        .'E;' //Tipo codigo barras
                        .trim($value['codigo_barras']).';' //Codigo barras
                        .trim($value['unidad_medida']).';' //Tipo embalaje 
                        .'UN;' //Unida producto
                        .((int)$value['volumen']*1000).';' //Volumen embalaje 
                        .trim($value['estado']).';' //Volumen embalaje 
                        .$fechaRegistro."\n";
                fwrite($archivo, $txt);
            }
            fwrite($archivo, 'E');
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
        //Requeire las referencias para consultar el inventario ----------------
        $this->_getInventario();
        //Rquiere las referencias para consultar las ventas --------------------
        $this->_getVentas();        
    }                                 
    
    /**
     * Metodo para crear el archivo con los clientes
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getClientes(){                            
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR.self::AR_CLIENTES
                .date('Ymd').self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------        
        $clientes = $this->_getClientesSiesa($this->nits);          
        if(count($clientes)>0){                        
            $txt = 'H;'.$this->nitJDH.';'.date('Ymd')."\n";
            fwrite($archivo, $txt);
            foreach ($clientes as $value) {                  
                $txt = 'V;' //Tipo de registro                        
                        .trim($value['nit']).'-'
                        .trim($value['cod_sucursal']).';' //NIT PDV
                        .substr(trim($value['nombre']),0,60).';' //Razon social 
                        .substr(trim($value['descripcion_sucursal']),0,60).';' //Nombre comercial
                        .'COL;' //Pais                        
                        .trim($value['departamento']).';' //Region
                        .trim(substr($value['departamento'], 0, 1)).';' //estado 
                        .trim($value['ciudad']).';' //ciudad
                        .self::DEFAULT_FIELD.';' //Barrio
                        .trim($value['direccion']).';' //Direccion
                        .self::DEFAULT_FIELD.';' //Grupo/Red
                        .self::DEFAULT_FIELD.';' //Clasificacion
                        .trim($value['codigo_vendedor']).' - '
                        .trim($value['nombre_vendedor']).';' //Nombre vendedor
                        .$value['fecha_ingreso'].';' //Fecha del registro
                        .'0000000;' //Codigo postal
                        .self::DEFAULT_FIELD.';' //Contacto   
                        .trim($value['estado']) //Estado
                        ."\n";
                fwrite($archivo, $txt);
            }
            fwrite($archivo, 'E');
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);
    }
    
    /**
     * Metodo para crear el archivo con el inventario actual, el invetario
     * esta diferido por bodega
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getInventario(){                           
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_INVENTARIO.date('Ymd').self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $inventario = $this->_getInventarioSiesa(array_keys($this->referencias));          
        if(count($inventario)>0){
            $txt = 'H;'.$this->nitJDH.';'
                    .date('Ymd', mktime(0, 0, 0, date('m'), 1, date('Y'))).';'
                    .date('Ymd')."\n";
            fwrite($archivo, $txt);
            foreach ($inventario as $value) { 
                if(isset($this->referencias[$value['codigo_producto']])){
                   $codigoB = $this->referencias[$value['codigo_producto']];
                }else{
                   $codigoB = self::DEFAULT_FIELD;
                }
                $txt = 'V;' //Tipo de registro
                        .trim($this->nitJDH).'-'.trim($value['co']).';' //Codigo tienda                        
                        .trim($value['nit_proveedor']).';' //Codigo proveedor
                        //.$value['proveedor'].';' //Codigo proveedor
                        .$codigoB.';' //Numero de barras
                        .';' //Numero de lote
                        .';' //Fechas validez note                        
                        .((int)$value['cantidad']*1000).';' //Cantidad
                        .'H;' //Tipo stock
                        .date('Ymd')."\n";
                fwrite($archivo, $txt);
            }
            fwrite($archivo, 'E');
        }                
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);             
    }
    
    
    
        
    /**
     * Metodo para crear el archivo con el listado de supervisores
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVentas(){        
        $totalVentas = 0;
        $arrayClientes = [];          
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_VENTAS.date('Ymd').self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");
        //Insertamos los registros en el archivo -------------------------------
        $ventas = $this->_getVentasSiesa(array_keys($this->referencias));
        $this->nits = ArrayHelper::map($ventas, 'nit', 'nit');        
        $this->vendedores = ArrayHelper::map($ventas, 'codigo_vendedor', 'codigo_vendedor');        
        if(count($ventas)>0){                         
                        
            $txt = 'H;'.$this->nitJDH.';'
                    .date('Ymd', strtotime($this->fechaIn)).';'
                    .date('Ymd', strtotime($this->fechaFn))."\n";
            fwrite($archivo, $txt);

            foreach ($ventas as $value) {  
                    if(isset($this->referencias[$value['codigo_producto']])){
                        $codigoB = $this->referencias[$value['codigo_producto']];
                    }else{
                        $codigoB = self::DEFAULT_FIELD;
                    }
                    $txt = 'V;' //Tipo de registro                                            
                        .trim($this->nitJDH).'-'.trim($value['co']).';'
                        .$this->nitUnilever.';' //Codigo proveedor
                        .$codigoB.';' //Numero de barras
                        .';' //Numero de lote
                        .';' //Fechas validez note                        
                        .((int)$value['cantidad']*1000).';' //Cantidad
                        .((int)$value['total_item_vendido']*100).';' //valor transaccion
                        .'COP;' //Moneda
                        .$value['numero_documento'].';' //Transaccion
                        .$value['fecha'].';' //Fecha tansaccion
                        .(($value['tipo']==1)? 'DV':'V').';' //Tipo tansaccion
                        //.'V;' //Tipo transaccion
                        .';' //Informacion complementaria  
                        .$value['tipo_nit'].';' //Tipo identificador PDV
                        .$value['nit'].';' //nit PDV
                        .substr(trim($value['nombre_sucursal']),0,60).';' //razon social PDV
                        .'0000000;' //codigo postal
                        .';' //Clasificacion PDV
                        .$value['codigo_vendedor'].' - '.$value['nombre_vendedor'].';'//Nombre vendedor
                        .';' //Identificacion Campo abierto 1                  
                        ."\n";
                    fwrite($archivo, $txt);
            }
            fwrite($archivo, 'E');                        
        }        
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);        
        $this->_getClientes();  
        $this->_getTiendas();
    }
    
    /**
     * Crea el archivo con el listado de las tiendas
     * 
     * @param int $totalVentas Total de las ventas 
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getTiendas(){          
        //Creamos el archivo ---------------------------------------------------
        $nombreArchivo = $this->directorio.DIRECTORY_SEPARATOR
                .self::AR_TIENDAS.date('Ymd').self::AR_EXT;
        $archivo = fopen($nombreArchivo, "w");                        
        //Insertamos los registros en el archivo -------------------------------          
        $tiendas = $this->_getListCO();            
        //$tiendas = $this->_getClientesSiesa($this->nits);          
        if(count($tiendas)>0){                         
            $txt = 'H;'.$this->nitJDH.';'                    
                    .date('Ymd')."\n";
            fwrite($archivo, $txt);
            foreach ($tiendas as $value) {
                $txt = 'V;' //Tipo de registro
                        .trim($this->nitJDH).'-'.trim($value['codigo']).';' //Codigo tienda                        
                        .trim($value['nombre']).';' //Descripcion tienda                                                
                        .trim(substr($value['nombre'], 0, 1)).';' //estado                                               
                        .trim($value['nombre']).';' //Ciudad                                               
                        .self::DEFAULT_FIELD.';' //Barrio                                               
                        .'0000000;' //Codigo postal                                               
                        .trim($value['estado']) //Estado tienda                                               
                        ."\n";
                fwrite($archivo, $txt);
            }
            fwrite($archivo, 'E');                        
        }        
        //Cerramos el archivo --------------------------------------------------
        fclose($archivo);               
    }    
    
    /**
     * Metodo para crear el archivo comprimido 
     * 
     * @param string $directorio    Directorio del archivo
     * @param string $nombreArchivo Nombre del archivo
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _crearZip($directorio, $nombreArchivo){
        try {
            //Eliminamos los Zip anteriores ------------------------------------
//            $mask = "*.jpg";
//            array_map( "unlink", glob( $mask ) );
            //------------------------------------------------------------------
            $zip = new ZipArchive();
            //$zip->open($nombreArchivo,ZipArchive::CREATE);
            $zip->open($this->directorio.DIRECTORY_SEPARATOR
                        .$nombreArchivo,ZipArchive::CREATE);
            //Adjuntamos los archivos ------------------------------------------
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_VENTAS.self::AR_EXT,self::AR_VENTAS.self::AR_EXT);        
            //$zip->addFile($directorio.DIRECTORY_SEPARATOR
            //        .self::AR_MUNICIPIOS.self::AR_EXT,self::AR_MUNICIPIOS.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_SKU.self::AR_EXT,self::AR_SKU.self::AR_EXT);        
            //$zip->addFile($directorio.DIRECTORY_SEPARATOR
            //        .self::AR_TIPOS_NEGOCIO.self::AR_EXT,self::AR_TIPOS_NEGOCIO.self::AR_EXT);        
            //$zip->addFile($directorio.DIRECTORY_SEPARATOR
            //        .self::AR_VENDEDORES.self::AR_EXT,self::AR_VENDEDORES.self::AR_EXT);        
            //$zip->addFile($directorio.DIRECTORY_SEPARATOR
            //        .self::AR_SUPERVISORES.self::AR_EXT,self::AR_SUPERVISORES.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_CLIENTES.self::AR_EXT,self::AR_CLIENTES.self::AR_EXT);        
            $zip->addFile($directorio.DIRECTORY_SEPARATOR
                    .self::AR_INVENTARIO.self::AR_EXT,self::AR_INVENTARIO.self::AR_EXT);                      
            //$zip->addFile($directorio.DIRECTORY_SEPARATOR
            //        .self::AR_TOTALES_CONTROL.self::AR_EXT,self::AR_TOTALES_CONTROL.self::AR_EXT);        
            $zip->close();
        } catch (\Exception $exc) {           
            \Yii::error( __FILE__ . ':' . __LINE__. '{' 
                    . $exc->getTraceAsString() . '}', 'unilever');
        }        
    }
    
    /**
     * Metodo para enviar el archivo por FTP
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _sendFileFTP(){  
        try {                                          
            //$this->_crearZip($this->directorio, $this->archivoZip);
            //----------------------------------------------------------------------
            //$file = $this->directorio.DIRECTORY_SEPARATOR
            //            .$this->archivoZip;            
            //$remote_file = $fileFtp =  '/'.$this->archivoZip;             
            // establecer una conexión básica
            $conn_id = ftp_connect($this->serv_ftp);                
            // iniciar sesión con nombre de usuario y contraseña
            ftp_login($conn_id, $this->us_ftp, $this->pass_ftp);        
            ftp_pasv($conn_id, true);
            // cargar un archivo
            $arrFiles = [];
            $arrFiles[] = $this->directorio.DIRECTORY_SEPARATOR
                    .self::AR_VENTAS.date('Ymd').self::AR_EXT;
            $arrFiles[] = $this->directorio.DIRECTORY_SEPARATOR
                    .self::AR_SKU.date('Ymd').self::AR_EXT;
            $arrFiles[] = $this->directorio.DIRECTORY_SEPARATOR
                    .self::AR_CLIENTES.date('Ymd').self::AR_EXT;
            $arrFiles[] = $this->directorio.DIRECTORY_SEPARATOR
                    .self::AR_INVENTARIO.date('Ymd').self::AR_EXT;
            $arrFiles[] = $this->directorio.DIRECTORY_SEPARATOR
                    .self::AR_TIENDAS.date('Ymd').self::AR_EXT;
            
            foreach ($arrFiles as $file) {
                $remote_file = str_replace($this->directorio.DIRECTORY_SEPARATOR, '', $file);
                if (ftp_put($conn_id, $remote_file, $file, FTP_ASCII)) {                           
                    \Yii::error( __FILE__ . ':' . __LINE__.'{ Transferencia con exito (' 
                        . $file . ')}', 'unilever');
                } else {                
                    \Yii::error( __FILE__ . ':' . __LINE__. '{ Error al transferir (' 
                        . $file . ')}', 'unilever');
                }
            }
            // cerrar la conexión ftp-----------------------------------------------
            ftp_close($conn_id);
        } catch (\Exception $exc) {           
            \Yii::error( __FILE__ . ':' . __LINE__. '{' 
                    . $exc->getMessage() . '}', 'unilever');
        }                
    }
        
    /**
     * Obtiene el listado de items por el bombre del fabricante
     * 
     * @param string $fabricantes Nombre de los fabricantes
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _ItemsXFrabricanteSiesa($fabricantes){
        $andWhere = '';
        if(is_array($fabricantes) && count($fabricantes)>0){
            $andWhere = " AND f106_descripcion IN('".implode("','", $fabricantes)."')";
        }
        try {
            $query = "
                SELECT 
                    RTRIM(LTRIM(f120_referencia)) AS codigo_producto, 
                    f120_descripcion AS descripcion,
                    f131_id_unidad_medida AS unidad_medida,
                    f131_cant_unidad_medida as volumen, 
                    LTRIM(RTRIM(f106_id)) as grupo_id, 
                    f106_descripcion as grupo,
                    f131_id as codigo_barras,    
                    (CASE WHEN f121_ind_estado = 1 THEN 'A' ELSE 'I' END) AS estado,
                    CONVERT(VARCHAR,f121_fecha_creacion,112) as fecha_registro
                FROM t120_mc_items 
                JOIN t121_mc_items_extensiones ON f121_rowid_item = f120_rowid
                JOIN t125_mc_items_criterios ON f120_rowid = f125_rowid_item
                JOIN t131_mc_items_barras ON f131_rowid_item_ext = f121_rowid
                JOIN t106_mc_criterios_item_mayores 
                     ON f106_id_plan = f125_id_plan 
                     AND f106_id = f125_id_criterio_mayor
                WHERE f106_id_plan = 1 ".$andWhere."
                ORDER BY f120_descripcion
                ";            
            return Yii::$app->dbsql->createCommand($query)->queryAll();
        } catch (\Exception $exc) {            
            \Yii::error( __FILE__ . ':' . __LINE__. '{' 
                    . $exc->getMessage() . '}', 'unilever');
            return [];
        }         
    }
    
    /**
     * Metodo para la consulta de inventario
     * 
     * @param array $referencias Array de las referencias
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function _getInventarioSiesa($referencias){
        $andWhere = "";
        if(is_array($referencias) && count($referencias)>0){
            $andWhere .= " AND T120.f120_referencia IN ('".implode("','", $referencias)."')";
        }
        $fechaE = date('d-m-Y');            
        $fechaIn = date('d-m-Y', strtotime('-1 month'));        
        $query = "
            SET NOCOUNT ON;			
            Declare 
                @Nit_Proveedor char(13), 
                @Id_Sucursal char(3),
                @Id_Cia int, 
                @Id_bodega Char(13),
                @Fecha_I Datetime, 
                @Fecha_F Datetime,
                @Fecha_E Datetime

            set @Nit_proveedor =''
            set @Id_Sucursal = ''
            set @Id_Cia = 1
            Set @Id_bodega = '' 
            Set @Fecha_F = '".$this->fechaFn."'
            Set @Fecha_I = '".$this->fechaIn."'
            Set @Fecha_E = '".$this->fechaEn."'

            SELECT
                RTRIM(LTRIM(T120.f120_referencia)) as codigo_producto,
                T120.f120_id as item, 
                T120.f120_descripcion as nombre, 
                RTRIM(LTRIM(ISNULL(qry.Bodega,' '))) as bodega,
                RTRIM(LTRIM(ISNULL(qry.co,' '))) as co,
                RTRIM(LTRIM(ISNULL(qry_prov.proveedor,' '))) as nit_proveedor,
                ISNULL(qry_prov.Nombre_proveedor,' ') as proveedor,
                -- ISNULL(qry_prov.Sucursal_proveedor,' ') as sucursal_id,
                -- ISNULL(qry_prov.Nombre_Sucursal,' ') as sucursal,
                'UNID' AS unidad_medida,		
                CONVERT(INT, ISNULL(SUM(qry.Cantidad_Disponible),0)) As cantidad_disponible,
                CONVERT(INT, ISNULL(SUM(qry.Cantidad_comprometida),0)) As Cantidad_comprometida, 
                CONVERT(INT, ISNULL((CASE WHEN (SUM(qry.Cantidad_Disponible))=0 THEN 0 ELSE ((SUM(qry.Cantidad_Disponible)) - (SUM(qry.Cantidad_comprometida))) END),0)) AS cantidad	
            FROM (
            
            -- QUERY PEDIDOS
            SELECT                
                MPV.f431_rowid_item_ext AS RItem,
                T150.f150_id AS Bodega,
                T150.f150_id_co AS co,
                T150.F150_id_instalacion As Instalacion,
                SUM(MPV.F431_CANT1_PEDIDA) AS Cantidad_comprometida,
                0 AS Cantidad_Disponible
            FROM
            T430_CM_PV_DOCTO PV 
            
            INNER JOIN T431_CM_PV_MOVTO MPV
                ON PV.F430_ROWID = MPV.F431_ROWID_PV_DOCTO

            LEFT JOIN t121_mc_items_extensiones T121
                ON T121.f121_rowid = MPV.f431_rowid_item_ext

            LEFT JOIN t120_mc_items T120
                ON T120.f120_rowid = T121.f121_rowid_item

            LEFT JOIN t150_mc_bodegas T150
                ON MPV.F431_ROWID_BODEGA = T150.f150_rowid

            WHERE
                PV.f430_id_cia = @Id_Cia
                AND PV.f430_ind_estado NOT IN(4,9)
                AND PV.f430_id_fecha BETWEEN @fecha_I AND @fecha_F
                AND PV.f430_ind_facturado = 0
                AND PV.f430_ind_remisionado = 0
                
            GROUP BY                                
                F150_id_instalacion,
                MPV.f431_rowid_item_ext,
                T150.f150_id_co,
                T150.f150_id

            UNION    

            --QUERY INVENTARIOS Act
                Select
                    T470.F470_ROWID_ITEM_EXT AS RItem,
                    T150.F150_ID As Bodega,
                    T150.f150_id_co AS co,
                    T470.F470_id_instalacion As Instalacion,	  
                    0 AS Cantidad_comprometida,
                    Sum(CASE WHEN T470.F470_IND_NATURALEZA = 1 THEN T470.F470_CANT_1 ELSE T470.F470_CANT_1*-1 END) As Cantidad_Disponible	  	  
                FROM
                    (T150_MC_BODEGAS T150 Right Outer Join
                    T470_CM_MOVTO_INVENT T470 
                    On T150.F150_ROWID = T470.F470_ROWID_BODEGA)
                -- Cruzamos con las bodegas principales
                JOIN 
                    (SELECT f150_descripcion AS bodega, f150_id AS id_bodega
                            FROM t150_mc_bodegas
                            JOIN t152_mc_bodega_grupo_bodega ON f152_rowid_bodega = f150_rowid
                            JOIN t151_mc_grupo_bodega ON f152_id_grupo_bodega = f151_id
                            WHERE f151_id IN ('BPP') ) AS GB
                    ON GB.id_bodega = T150.F150_ID
                WHERE
                    T470.F470_ID_CIA = @Id_CIA
                    -- AND T150.F150_ID = @Id_bodega
                    AND T470.F470_ID_fecha <= @Fecha_E 
                    AND T470.F470_IND_ESTADO_CM  <> '2' 
                    AND T470.F470_IND_TIPO_ITEM = 1	  	  
                GROUP BY
                    T470.F470_ROWID_ITEM_EXT,
                    T150.f150_id_co,
                    T150.F150_ID,
                    T470.F470_id_instalacion
                ) qry
	
            FULL JOIN t121_mc_items_extensiones T121
                On qry.ritem = T121.f121_rowid
	
            INNER JOIN t120_mc_items T120
                On T121.f121_rowid_item = T120.f120_rowid
                AND T120.F120_IND_TIPO_ITEM = '1'
	  
            --QUERY PROVEEDORES 
            LEFT JOIN (
                SELECT 
                    t470_comp.f470_rowid_item_ext AS RItem,
                    T200.f200_id AS Proveedor,
                    T200.f200_razon_social AS Nombre_Proveedor,
                    dtocmp.f451_id_sucursal_prov AS Sucursal_proveedor,
                    T202.f202_descripcion_sucursal as Nombre_Sucursal,
                    RANK() OVER (PARTITION BY t470_comp.f470_rowid_item_ext ORDER BY SUM(CASE WHEN t470_comp.f470_ind_naturaleza = 2 THEN (-t470_comp.f470_cant_1) ELSE t470_comp.f470_cant_1 END) DESC) as Rango
                FROM t470_cm_movto_invent t470_comp
		INNER JOIN t451_cm_docto_compras dtocmp ON dtocmp.f451_rowid_docto = t470_comp.f470_rowid_docto
		INNER JOIN t350_co_docto_contable t350_t1 ON t350_t1.f350_rowid = t470_comp.f470_rowid_docto
		LEFT JOIN t200_mm_terceros T200 ON dtocmp.f451_rowid_tercero_prov = T200.f200_rowid
		LEFT JOIN t202_mm_proveedores T202 ON dtocmp.f451_id_sucursal_prov = T202.f202_id_sucursal AND T200.f200_rowid = T202.f202_rowid_tercero
                WHERE 
                    t350_t1.f350_id_clase_docto IN (408, 409, 410, 411, 412, 413, 414, 417, 420)
                    -- AND (t470_comp.f470_id_fecha BETWEEN DATEADD(month, -6,@Fecha_F) AND @Fecha_F )
                    -- AND T200.f200_id = @Nit_proveedor
                    -- AND dtocmp.f451_id_sucursal_prov = @id_sucursal 
                GROUP BY 
                    t470_comp.f470_rowid_item_ext, 
                    T200.f200_id,
                    T200.f200_razon_social,
                    T202.f202_descripcion_sucursal,
                    dtocmp.f451_id_sucursal_prov
                ) qry_prov
                ON qry.ritem = qry_prov.ritem
                AND qry_prov.RANGO = 1
        
            WHERE 
                qry.Bodega IS NOT NULL 
                AND qry_prov.proveedor IS NOT NULL
                ".$andWhere."
	
            GROUP BY 
                T120.f120_referencia,
                T120.f120_id,
                T120.f120_descripcion, 
                T120.F120_IND_TIPO_ITEM,
                qry.Bodega,
                qry.co,
                qry_prov.proveedor,
                qry_prov.Nombre_proveedor,
                qry_prov.Sucursal_proveedor,
                qry_prov.Nombre_Sucursal

            ORDER BY 
                T120.f120_referencia, 
                T120.f120_id,
                qry.Bodega,
                qry_prov.proveedor,
                qry_prov.Nombre_proveedor,
                qry_prov.Sucursal_proveedor                
	";         
        return Yii::$app->dbsql->createCommand($query)->queryAll();
    }
    
    /**
     * Retorna las ventas de cada cliente deacuerdo al listado de referencias 
     * 
     * @param array $referencias Array de referencias
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getVentasSiesa($referencias){                                                                
        $andWhere = "";
        if(is_array($referencias) && count($referencias)>0){
            $andWhere .= " AND T120.f120_referencia IN ('".implode("','", $referencias)."')";
        }
        $query =
        "DECLARE @Nit_cliente CHAR(13), @C_Sucursal VARCHAR(3), @fecha_dto_ini DATETIME, @fecha_dto_fin DATETIME, @Id_Cia INT            

        SET @fecha_dto_ini = '" . $this->fechaIn . "'
        SET @fecha_dto_fin = '" . $this->fechaFn . "'
        SET @Id_Cia = 1

        SELECT
            -- f470_rowid AS id,
            ClienteFact.f200_rowid AS codigo_cliente,
            FV.f461_rowid_tercero_vendedor AS codigo_vendedor,
            Vendedor.f200_razon_social as nombre_vendedor,
            RTRIM(LTRIM(f350_id_tipo_docto)) + '-' + CONVERT(VARCHAR,(REPLICATE('0', (8 - LEN(f350_consec_docto))) + CONVERT(VARCHAR,f350_consec_docto)))  AS numero_documento,
            ClienteFact.f200_nit as nit,
            ClienteFact.f200_ind_tipo_tercero as tipo_nit,            
            FV.F461_ID_SUCURSAL_FACT as sucursal,
            C201.F201_DESCRIPCION_SUCURSAL AS nombre_sucursal,
            T120.f120_descripcion as descripcion,
            CONVERT(VARCHAR,DOCFAC.f350_fecha,112) as fecha,
            RTRIM(LTRIM(T120.f120_referencia)) as codigo_producto,
            ISNULL(T132.f132_ultimo_costo_local,0) AS costo,                
            SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1 ELSE MFV.f470_cant_1 END)) AS cantidad,
            SUM((CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN (MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea) ELSE MFV.f470_vlr_neto-MFV.f470_vlr_imp-MFV.f470_vlr_dscto_linea END)) AS total_item_vendido,
            MFV.f470_id_co_movto AS co,
            'UNID' AS unidad_medida,            
            (CASE WHEN RTRIM(LTRIM(f350_id_tipo_docto)) IN ('FV', 'FVE', 'FEV') THEN 0 ELSE 1 END) AS tipo,
	    RTRIM(LTRIM(f430_id_tipo_docto)) + '-' + CONVERT(VARCHAR,(REPLICATE('0', (8 - LEN(PV.f430_consec_docto))) + CONVERT(VARCHAR,PV.f430_consec_docto)))  AS numero_pedido

        FROM t470_cm_movto_invent MFV 

        INNER JOIN t461_cm_docto_factura_venta FV
            ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto

        INNER JOIN t350_co_docto_contable DOCFAC
            ON DOCFAC.f350_rowid = FV.f461_rowid_docto

        -- LEFT JOIN t121_mc_items_extensiones T121
        INNER JOIN t121_mc_items_extensiones T121
            ON T121.f121_rowid = MFV.f470_rowid_item_ext

        -- LEFT JOIN t120_mc_items T120
        INNER JOIN t120_mc_items T120
            ON T120.f120_rowid = T121.f121_rowid_item            

        -- LEFT JOIN t200_mm_terceros ClienteFact
        INNER JOIN t200_mm_terceros ClienteFact
            ON ClienteFact.f200_rowid = FV.f461_rowid_tercero_fact

        INNER JOIN t200_mm_terceros Vendedor
            ON Vendedor.f200_rowid = FV.f461_rowid_tercero_vendedor

        INNER JOIN T201_MM_CLIENTES C201
            ON ClienteFact.F200_ROWID = C201.F201_ROWID_TERCERO
            AND FV.F461_ID_SUCURSAL_FACT = C201.F201_ID_SUCURSAL    
            
        LEFT JOIN t431_cm_pv_movto
            ON f470_rowid_pv_movto = f431_rowid
			
        LEFT JOIN T430_CM_PV_DOCTO PV 
            ON f431_rowid_pv_docto = f430_rowid

        LEFT JOIN T132_Mc_items_instalacion T132 
            ON T132.f132_rowid_item_ext = MFV.f470_rowid_item_ext
            AND T132.f132_id_instalacion = MFV.f470_id_instalacion
            AND T132.f132_id_cia =  @Id_CIA
            AND T132.f132_id_instalacion is not null 

        WHERE
            FV.f461_id_cia = @Id_Cia 
            AND DOCFAC.f350_id_tipo_docto IN ('FV', 'NC', 'NCD', 'NCE', 'FVE', 'NFC', 'NEF', 'NDF', 'FEV', 'NDE', 'NED', 'NFE', 'DEF', 'NCF')
            AND DOCFAC.f350_fecha BETWEEN @fecha_dto_ini AND @fecha_dto_fin           
            ".$andWhere."

        GROUP BY
            -- f470_rowid,
            ClienteFact.f200_rowid,
            f461_rowid_docto,
            ClienteFact.f200_nit,
            ClienteFact.f200_ind_tipo_tercero,
            FV.F461_ID_SUCURSAL_FACT, 
            C201.F201_DESCRIPCION_SUCURSAL, 
            T120.f120_referencia, 
            T120.f120_descripcion, 
            DOCFAC.f350_fecha,
            FV.f461_rowid_tercero_vendedor,
            MFV.f470_id_co_movto,
            T132.f132_ultimo_costo_local,
            f350_id_tipo_docto,
            f350_consec_docto,
            f430_id_tipo_docto,
            PV.f430_consec_docto,
            Vendedor.f200_razon_social
            
        ORDER BY
            ClienteFact.f200_nit, 
            FV.F461_ID_SUCURSAL_FACT, 
            T120.f120_referencia, 
            T120.f120_descripcion, 
            DOCFAC.f350_fecha
            ";
		
        $arrayResultQuery = Yii::$app->dbsql->createCommand($query)->queryAll();        
        return $arrayResultQuery;
    }
    
    /**
     * Retorna la informacion de cada NIT
     * 
     * @param array $nits Array de Nit
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getClientesSiesa($nits){ 
        $andWhere = '';
        if(is_array($nits) && count($nits)>0){
            $andWhere = " AND cli.f200_nit IN('".implode("','", $nits)."')";
        }
        $query = "
            SELECT 
                RTRIM(LTRIM(cli.f200_rowid)) as codigo,
                cli.f200_razon_social as nombre,
                suc.f201_id_sucursal cod_sucursal,
                suc.f201_descripcion_sucursal descripcion_sucursal,
                dven.f200_nit as codigo_vendedor,
                dven.f200_razon_social as nombre_vendedor,
                CONVERT(VARCHAR,cli.f200_fecha_nacimiento,112) as fecha_ingreso,                
                cli.f200_nit as nit,            
                ccli.f015_direccion1 as direccion, 
                ccli.f015_id_pais + ccli.f015_id_depto + ccli.f015_id_ciudad as codigo_municipio,
                f012_descripcion as departamento,
                f013_descripcion as ciudad,
                f204_descripcion,
                f207_id_plan_criterios,
                f207_id_criterio_mayor as id_tipo_negocio,
                f206_descripcion,                
                (CASE WHEN cli.f200_ind_estado = 1 THEN 'A' ELSE 'I' END) AS estado
            FROM t200_mm_terceros cli
            JOIN t015_mm_contactos as ccli ON ccli.f015_rowid = cli.f200_rowid_contacto
            JOIN t013_mm_ciudades ON f015_id_pais = f013_id_pais AND ccli.f015_id_depto = f013_id_depto AND ccli.f015_id_ciudad = f013_id
            JOIN t012_mm_deptos ON ccli.f015_id_depto = f012_id AND ccli.f015_id_pais = f012_id_pais
            JOIN t207_mm_criterios_clientes ON f207_rowid_tercero = cli.f200_rowid AND f207_id_sucursal = '001'
            JOIN t204_mm_planes_criterios ON f204_id = f207_id_plan_criterios AND f204_id = '014'
            JOIN t206_mm_criterios_mayores ON f206_id = f207_id_criterio_mayor
            
            JOIN t201_mm_clientes AS suc ON cli.f200_rowid = suc.f201_rowid_tercero
            JOIN t210_mm_vendedores AS ven ON ven.f210_id = suc.f201_id_vendedor
            JOIN t200_mm_terceros AS dven ON dven.f200_rowid = ven.f210_rowid_tercero
            JOIN t015_mm_contactos AS con ON con.f015_rowid = dven.f200_rowid_contacto
            
            WHERE 
                cli.f200_nit IS NOT NULL AND cli.f200_ind_estado = 1 
                AND cli.f200_ind_cliente = 1
                ".$andWhere."
            ORDER BY cli.f200_razon_social ASC";
        return Yii::$app->dbsql->createCommand($query)->queryAll();                
    }
    
    /**
     * Retorna el listado de los Centros de operacion
     * 
     * @return array
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    private function _getListCO(){
        $query = "SELECT f285_id AS codigo, f285_descripcion as nombre,                 
                (CASE WHEN f285_ind_estado = 1 THEN 'A' ELSE 'I' END) AS estado
                FROM t285_co_centro_op";        
        return Yii::$app->dbsql->createCommand($query)->queryAll();  
    }
}
