<?php

namespace app\components;

use yii\helpers\Html;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Util.php
 *
 * // CLASE PARA FUNCIONES UTILES PARA TODO EL SISTEMA
 *
 * @category  category
 * @package   package
 * @author    Felipe Echeverri <felipe.echeverri@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class Util {
   
    /**
     * Retorna listado de estados
     * 
     * @param string $estado
     * @return string
     * 
     * @author    Felipe Echeverri <felipe.echeverri@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getEstados($estado) {
        $spanEstado = "";
        switch ($estado) {
            case "0":
                $spanEstado = Html::tag('span', 'Activo', ['class' => 'label label-success']);
                break;            
            case "1":
                $spanEstado = Html::tag('span', 'Inactivo', ['class' => 'label label-danger']);
                break;
            default:
                $spanEstado = Html::tag('span', 'SIN ESTADO', ['class' => 'label label-default']);
                break;
        }
        return $spanEstado;
    }
    
    /**
     * Retorna listado de estados
     * 
     * @param string $estado
     * @return string
     * 
     * @author    Felipe Echeverri <felipe.echeverri@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getActivo($estado) {
        $spanEstado = "";
        switch ($estado) {
            case "SI":
                $spanEstado = Html::tag('span', 'SI', ['class' => 'label label-success']);
                break;            
            case "NO":
                $spanEstado = Html::tag('span', 'NO', ['class' => 'label label-danger']);
                break;
            default:
                $spanEstado = Html::tag('span', 'SIN ESTADO', ['class' => 'label label-default']);
                break;
        }
        return $spanEstado;
    }
    
    /**
     * Retorna listado de estados
     * 
     * @param string $estado
     * @return string
     * 
     * @author    Felipe Echeverri <felipe.echeverri@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getBorrado($estado) {
        $spanEstado = "";
        switch ($estado) {
            case "0":
                $spanEstado = Html::tag('span', 'SI', ['class' => 'label label-success']);
                break;            
            case "1":
                $spanEstado = Html::tag('span', 'NO', ['class' => 'label label-danger']);
                break;
            default:
                $spanEstado = Html::tag('span', 'SIN ESTADO', ['class' => 'label label-default']);
                break;
        }
        return $spanEstado;
    }
    
    /**
     * Retorna el trimestre (meses) del mes en curso
     * 
     * @return array
     * @author    Alexander ARcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public static function getTrimestre(){
        $trim = floor((date('m')-1) / 3)+1;
        switch ($trim) {
            case 2:
                return ['Abril','Mayo','Junio'];
                break;
            case 3:
                return ['Julio','Agosto','Septiembre'];
                break;
            case 4:
                return ['Octubre','Noviembre','Diciembre'];
                break;
            default:
                return ['Enero','Febrero','Marzo'];
                break;
        }
    }
    
    /**
     * 
     * @param type $porcentaje
     * @return string
     */
    public static function getClassProgress($porcentaje){
        $classProg = 'progress-bar-red';
        if($porcentaje < 25){
            $classProg = 'progress-bar-red';
        }
        if($porcentaje >= 25 && $porcentaje < 50){
            $classProg = 'progress-bar-yellow';
        }
        if($porcentaje >= 50 && $porcentaje < 75){
            $classProg = 'progress-bar-aqua';
        }
        if($porcentaje >= 75){
            $classProg = 'progress-bar-green';
        }
        return $classProg;
    }
    
}
