<?php

$params = require(__DIR__ . '/params.php');
$db = require(__DIR__ . '/db.php');
$dbsql = require(__DIR__ . '/dbSQL.php');

$config = [
    'id' => 'tracksales-console',
    'basePath' => dirname(__DIR__),
    'bootstrap' => ['log'],
    'controllerNamespace' => 'app\commands',
    'modules' => [        
        'gridview' => [
            'class' => '\kartik\grid\Module'
        ]
    ],
    'components' => [
        'cache' => [
            'class' => 'yii\caching\FileCache',
        ],
        'authManager' => [
            'class' => 'yii\rbac\DbManager',
        ],
        'log' => [
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                    'categories' => ['tracksales'],
                    'logFile' => '@app/runtime/tracksales/tracksales' . date('Ymd') . '.log',
                    'maxFileSize' => 1024 * 2,
                    'maxLogFiles' => 10,
                ],
            ],
        ],
        'db' => $db,
        'dbsql' => $dbsql,
//        'urlManager' => [
//            'class' => 'yii\web\UrlManager',
//            'scriptUrl' => 'http://190.0.20.194/familia',
//            'baseUrl' => 'http://190.0.20.194/familia',
//            //'enablePrettyUrl' => true,
//            //'showScriptName' => false,
//            // ...
//         ],
        'mailer' => [
            'class' => 'yii\swiftmailer\Mailer',
            //'useFileTransport' => true,
            // send all mails to a file by default. You have to set
            // 'useFileTransport' to false and configure a transport
            // for the mailer to send real emails.
            'transport' => [
                'class' => 'Swift_SmtpTransport',                
                'host' => 'smtpout.secureserver.net',                
                'username' => 'alexander.arcila@ingeneo.com.co',                
                'password' => 'AAA.2020',
                //'port' => '465',
                //'encryption' => 'tls',
            ],
        ],
    ],
    'params' => $params,
        /*
          'controllerMap' => [
          'fixture' => [ // Fixture generation command line.
          'class' => 'yii\faker\FixtureController',
          ],
          ],
         */
];

if (YII_ENV_DEV) {
    // configuration adjustments for 'dev' environment
    $config['bootstrap'][] = 'gii';
    $config['modules']['gii'] = [
        'class' => 'yii\gii\Module',
    ];
}

return $config;
