<?php

$params = require(__DIR__ . '/params.php');

$config = [
    'id' => 'basic',
    'basePath' => dirname(__DIR__),
    'bootstrap' => ['log'],
    'name' => 'AB',
    'modules' => [
        'admin' => [
            'class' => 'mdm\admin\Module',
            //'layout' => 'left-menu',
            'controllerMap' => [
                'assignment' => [
                    'class' => 'mdm\admin\controllers\AssignmentController',
                    'userClassName' => 'app\models\Usuarios', // fully qualified class name of your User model
                    // Usually you don't need to specify it explicitly, since the module will detect it automatically
                    //'idField' => 'id',        // id field of your User model that corresponds to Yii::$app->user->id
                    //'usernameField' => 'username', // username field of your User model
                    'searchClass' => 'app\models\UsuariosSearch'    // fully qualified class name of your User model for searching
                ]
            ],
        ],
        'gridview' => [
            'class' => '\kartik\grid\Module'
        // enter optional module parameters below - only if you need to  
        // use your own export download action or custom translation 
        // message source
        // 'downloadAction' => 'gridview/export/download',
        // 'i18n' => []
        ]
    ],
    'components' => [
        'assetManager' => [
            'bundles' => [
                'dmstr\web\AdminLteAsset' => [
                    //'skin' => 'skin-blue-light',
                    'skin' => 'skin-black-light',
                ],
            ],
        ],
        'session' => [            
            'name' => '_b2bi', // unique for backend
            'savePath' => __DIR__ . '/../runtime', // a temporary folder on backend
        ],
        'util' => [
            'class' => 'app\components\Util',
        ],
        'request' => [
            // !!! insert a secret key in the following (if it is empty) - this is required by cookie validation
            'cookieValidationKey' => 'sBL3Aaoxxblyw_xQC3pGa1mI348XlCIj',
        ],
        'cache' => [
            'class' => 'yii\caching\FileCache',
        ],
        'user' => [
            'identityClass' => 'app\models\User',
            'enableAutoLogin' => true,
        ],
        'errorHandler' => [
            'errorAction' => 'site/error',
        ],
        'mailer' => [
            'class' => 'yii\swiftmailer\Mailer',
            //'useFileTransport' => true,
            // send all mails to a file by default. You have to set
            // 'useFileTransport' to false and configure a transport
            // for the mailer to send real emails.
            'transport' => [
                'class' => 'Swift_SmtpTransport',                
//                'host' => 'smtpout.secureserver.net',                
//                'username' => 'alexander.arcila@ingeneo.com.co',                
//                'password' => 'AAA.2020',
                'host' => 'smtp.gmail.com',                
                'username' => 'soporteb2bjdh@gmail.com',
                'password' => 'jdh00175',
                'port' => '465',
                'SMTPAuth' => true,
                'SMTPSecure' => 'ssl',
                //'encryption' => 'tls',
            ],
        ],
        'log' => [
            'traceLevel' => YII_DEBUG ? 3 : 0,
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
            ],
        ],
        'db' => require(__DIR__ . '/db.php'),
        'dbsql' => require(__DIR__ . '/dbSQL.php'),
        'authManager' => [
            'class' => 'yii\rbac\DbManager',
        ],
        'view' => [
            'theme' => [
                'pathMap' => [                                    
                    '@vendor/mdmsoft/yii2-admin/views' => '@app/views'                    
                ],
            ],
        ],
    /* 'urlManager' => [
      'enablePrettyUrl' => true,
      'showScriptName' => false,
      'rules' => [
      ],
      ], */
    ],
    'params' => $params,
    'as access' => [
        'class' => 'mdm\admin\components\AccessControl',
        'allowActions' => [
            'site/login',
            'site/logout',            
            'site/repass',            
            //'gii'
            //'site/index',
            //'debug/*',
            //'admin/*',            
        ]
    ],
    'language' => 'es',
];

if (YII_ENV_DEV) {
    // configuration adjustments for 'dev' environment
    $config['bootstrap'][] = 'debug';
    $config['modules']['debug'] = [
        'class' => 'yii\debug\Module',
        'allowedIPs' => ['190.248.68.130', '192.168.100.3']
    ];

    $config['bootstrap'][] = 'gii';
    $config['modules']['gii'] = [
        'class' => 'yii\gii\Module',
        'allowedIPs' => ['190.248.68.130', '192.168.100.3']
    ];
}

return $config;
