<?php

namespace app\models;

use Yii;
use yii\db\ActiveRecord;
use yii\db\Expression;
use yii\behaviors\BlameableBehavior;
use yii\behaviors\AttributeBehavior;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * BeforeModel.php
 *
 * // Función encargada de validar el Tenant ID y todos sus métodos Before
 * Adicionalmente guarda las columnas de control 
 *
 * @category  category
 * @package   package
 * @author    Felipe Echeverri <felipe.echeverri@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class BeforeModel extends \yii\db\ActiveRecord {

    public function behaviors() {
        return [
            'timestamp' => [
                'class' => 'yii\behaviors\TimestampBehavior',
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['created', 'modified'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['modified'],
                ],
                'value' => new Expression('NOW()'),
            ],
            'blameable' => [
                'class' => BlameableBehavior::className(),
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['created_by', 'modified_by'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['modified_by'],
                ],
                'value' => isset(Yii::$app->user->identity->username) ? Yii::$app->user->identity->username
                            : '',
            ],
//            'tenant' => [
//                'class' => AttributeBehavior::className(),
//                'attributes' => [
//                    ActiveRecord::EVENT_BEFORE_VALIDATE => ['tenant_id'],
//                    ActiveRecord::EVENT_BEFORE_INSERT => ['tenant_id'],
//                    ActiveRecord::EVENT_BEFORE_UPDATE => ['tenant_id'],
//                ],
//                'value' => function ($event) {
//            /*
//             * SI NO ES ADMIN RETORNA EL TENANT_ID DE SESSION
//             * SI ES ADMIN RETORNA EL TENANT SELECCIONADO EN EL FORMULARIO                     * 
//             */
//            if (isset(\Yii::$app->user->identity)) {
////                return (!\Yii::$app->user->identity->isSuperAdmin()) ?
////                        Yii::$app->user->identity->tenant_id :
////                        $event->sender->tenant_id;
//            }
//        },
//            ],
        ];
    }

    public static function find() {
//        $strTable = self::getTableSchema();        
//        //$table = str_replace(['{', '}', '%'], '', $strTable);                
//        if (!empty(Yii::$app->user->identity) && !\Yii::$app->user->identity->isSuperAdmin()) {            
//            return parent::find()->andFilterWhere([$strTable->name.'.tenant_id' => Yii::$app->user->identity->tenant_id]);
//        } else {
            return parent::find();
//        }
    }

}
