<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "distribuidores".
 *
 * @property integer $id
 * @property integer $nit
 * @property string $razon_social
 * @property string $direccion
 * @property string $telefono
 * @property string $ciudad
 *
 * @property Compras[] $compras
 * @property Inventarios[] $inventarios
 * @property Referencias[] $referencias
 * @property Usuarios[] $usuarios
 * @property Ventas[] $ventas
 */
class Distribuidores extends \yii\db\ActiveRecord
{   
    
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'distribuidores';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['nit', 'razon_social'], 'required'],
            [['nit'], 'integer'],
            [['razon_social'], 'string', 'max' => 250],
            [['direccion'], 'string', 'max' => 300],
            [['telefono', 'ciudad'], 'string', 'max' => 45],            
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'nit' => Yii::t('app', 'Nit'),
            'razon_social' => Yii::t('app', 'Razon Social'),
            'direccion' => Yii::t('app', 'Direccion'),
            'telefono' => Yii::t('app', 'Telefono'),
            'ciudad' => Yii::t('app', 'Ciudad'),                        
        ];
    }      

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getInventarios()
    {
        return $this->hasMany(Inventarios::className(), ['distribuidor_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getReferencias()
    {
        return $this->hasMany(Referencias::className(), ['distribuidor_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUsuarios()
    {
        return $this->hasMany(Usuarios::className(), ['distribuidor_id' => 'id']);
    }    
}
