<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Logcargas;

/**
 * LogcargasSearch represents the model behind the search form about `app\models\Logcargas`.
 */
class LogcargasSearch extends Logcargas
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'fila', 'usuario_id'], 'integer'],
            [['mensaje', 'nomUsuario'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Logcargas::find()->joinWith('usuario');

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $dataProvider->sort->attributes['nomUsuario'] = [            
            'asc' => ['usuarios.nombre' => SORT_ASC],
            'desc' => ['usuarios.nombre' => SORT_DESC],
        ];
        
        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }                        

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'fila' => $this->fila,
            'usuario_id' => $this->usuario_id,
        ]);

        $query->andFilterWhere(['like', 'usuarios.nombre', $this->nomUsuario])
              ->andFilterWhere(['like', 'mensaje', $this->mensaje]);

        return $dataProvider;
    }
}
