<?php

namespace app\models;

use Yii;
use yii\behaviors\AttributeBehavior;
use yii\db\ActiveRecord;

/**
 * This is the model class for table "parametrosreportes".
 *
 * @property integer $id
 * @property string $reporte
 * @property string $paramsAdd
 * @property string $paramsDefecto
 * @property integer $usuario_id
 *
 * @property Usuarios $usuario
 */
class Parametrosreportes extends ActiveRecord
{
    
    public function behaviors() {
        return [
            'usuarios' => [
                'class' => AttributeBehavior::className(),
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_VALIDATE => ['usuario_id'],
                    ActiveRecord::EVENT_BEFORE_INSERT => ['usuario_id'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['usuario_id'],
                ],
                'value' => function ($event) {                            
                    return \Yii::$app->user->identity->id;
                },
            ],
        ];
    }
    
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'parametrosreportes';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['paramsAdd', 'paramsDefecto'], 'string'],
            [['usuario_id'], 'required'],
            [['usuario_id'], 'integer'],
            [['reporte'], 'string', 'max' => 200],
            [['usuario_id'], 'exist', 'skipOnError' => true, 'targetClass' => Usuarios::className(), 'targetAttribute' => ['usuario_id' => 'id']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'reporte' => Yii::t('app', 'Reporte'),
            'paramsAdd' => Yii::t('app', 'Params Add'),
            'paramsDefecto' => Yii::t('app', 'Params Defecto'),
            'usuario_id' => Yii::t('app', 'Usuario ID'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUsuario()
    {
        return $this->hasOne(Usuarios::className(), ['id' => 'usuario_id']);
    }
}
