<?php

namespace app\models;

use Yii;
use app\models\BeforeModel;

/**
 * This is the model class for table "preferencias".
 *
 * @property integer $id
 * @property string $nombre
 * @property string $valor
 * @property string $created
 * @property string $created_by
 * @property string $modified
 * @property string $modified_by
 * @property integer $tenant_id
 *
 * @property Tenants $tenant
 */
class Preferencias extends BeforeModel
{
    const USAR_WS_REST = 'si';
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'preferencias';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['nombre', 'valor', 'tenant_id'], 'required'],
            ['valor', 'filter', 'filter'=>'strtolower'],
            [['created', 'modified'], 'safe'],
            [['tenant_id'], 'integer'],
            [['nombre'], 'string', 'max' => 150],
            [['valor'], 'string', 'max' => 250],
            [['created_by', 'modified_by'], 'string', 'max' => 45],
            [['tenant_id'], 'exist', 'skipOnError' => true, 'targetClass' => Tenants::className(), 'targetAttribute' => ['tenant_id' => 'id']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'nombre' => Yii::t('app', 'Nombre'),
            'valor' => Yii::t('app', 'Valor'),
            'created' => Yii::t('app', 'Created'),
            'created_by' => Yii::t('app', 'Created By'),
            'modified' => Yii::t('app', 'Modified'),
            'modified_by' => Yii::t('app', 'Modified By'),
            'tenant_id' => Yii::t('app', 'Tenant ID'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getTenant()
    {
        return $this->hasOne(Tenants::className(), ['id' => 'tenant_id']);
    }
}
