<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Proyecciones;

/**
 * ProyeccionesSearch represents the model behind the search form about `app\models\Proyecciones`.
 */
class ProyeccionesSearch extends Proyecciones
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'anio', 'mes', 'meta_compras', 'meta_ventas', 'usuario_id'], 'integer'],
            [['nomUsuario'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Proyecciones::find()->joinWith('usuario');

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);
        
        $dataProvider->sort->attributes['nomUsuario'] = [            
            'asc' => ['usuarios.nombre' => SORT_ASC],
            'desc' => ['usuarios.nombre' => SORT_DESC],
        ];

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'anio' => $this->anio,
            'mes' => $this->mes,
            'meta_compras' => $this->meta_compras,
            'meta_ventas' => $this->meta_ventas,
            'usuario_id' => $this->usuario_id,
        ]);
        
        $query->andFilterWhere(['like', 'usuarios.nombre', $this->nomUsuario]);

        return $dataProvider;
    }
}
