<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\UsrBranchOffice;

/**
 * UsrBranchOfficeSearch represents the model behind the search form of `app\models\UsrBranchOffice`.
 */
class UsrBranchOfficeSearch extends UsrBranchOffice
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'id_user'], 'integer'],
            [['id', 'name_provider', 'name_branch_office', 'name_city'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $branchOffice = Yii::$app->runAction('usr-branch-office/get-branch-user');
        $query = UsrBranchOffice::find();

        // add conditions that should always apply here
        $dataProvider = new ActiveDataProvider([
            'query' => $query
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }
        // grid filtering conditions
        $query->andFilterWhere(['like', 'name_provider', trim($this->name_provider)])
            ->andFilterWhere(['like', 'code_provider', trim($this->code_provider)])
            ->andFilterWhere(['like', 'name_branch_office', trim($this->name_branch_office)])
            ->andFilterWhere(['like', 'name_city', trim($this->name_city)])
            ->andFilterWhere(['=', 'id_user', trim($this->id_user)]);
        return $dataProvider;
    }
}
