<?php
use yii\helpers\Html;

/* @var $this \yii\web\View */
/* @var $content string */
use app\models\Maquinas;

$usuId = Yii::$app->user->getId();
$roles = Yii::$app->authManager->getAssignments($usuId);
$countclientesnoerp  = 0;
?>

<header class="main-header">
    <?= Html::a('<span class="logo-mini">'.Html::img('img/logo-b2bi.png',['width'=>'30px']).'</span><span class="logo-lg">' . Html::img('img/logo-b2bi.png',['width'=>'70px']) . '</span>', Yii::$app->homeUrl, ['class' => 'logo'])
    ?>

    <nav class="navbar navbar-static-top" role="navigation">

        <a href="#" class="sidebar-toggle" data-toggle="push-menu" role="button">
            <span class="sr-only">Toggle navigation</span>
        </a>

        <div class="navbar-custom-menu">
            <ul class="nav navbar-nav">
                <?php if (\Yii::$app->user->identity->isAdmin()): ?>
                    <li class="dropdown notifications-menu">
                        <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                            <i class="fa fa-bell-o"></i>
                            <span class="label label-warning"><?= $countclientesnoerp ?></span>
                        </a>
                        <ul class="dropdown-menu">
                            <li class="header">Tienes <?= $countclientesnoerp ?> clientes no cruzados</li>
                            <li class="footer">
                                <?= Html::a(Yii::t('app', 'Ver Todos'),
                                    ['reportes/clientesnoerp']) ?>
                            </li>
                        </ul>
                    </li>
                <?php endif; ?>
                <li class="dropdown user user-menu">
                    <?=
                    Html::a(
                        '<span>' . Yii::$app->user->identity->username . '  <i class="fa fa-power-off"></i></span>', ['/site/logout'], ['data-method' => 'post',]
                    )
                    ?>
                    <ul class="dropdown-menu">
                        <!-- User image -->
                        <li class="user-header">
                            <img src="<?= $directoryAsset ?>/img/user2-160x160.jpg" class="img-circle"
                                 alt="User Image"/>

                            <p>
                                Alexander Pierce - Web Developer
                                <small>Member since Nov. 2012</small>
                            </p>
                        </li>
                        <!-- Menu Body -->
                        <li class="user-body">
                            <div class="col-xs-4 text-center">
                                <a href="#">Followers</a>
                            </div>
                            <div class="col-xs-4 text-center">
                                <a href="#">Sales</a>
                            </div>
                            <div class="col-xs-4 text-center">
                                <a href="#">Friends</a>
                            </div>
                        </li>
                        <!-- Menu Footer-->
                        <li class="user-footer">
                            <div class="pull-left">
                                <a href="#" class="btn btn-default btn-flat">Profile</a>
                            </div>
                            <div class="pull-right">
                                <?=
                                Html::a(
                                    'Sign out', ['/site/logout'], ['data-method' => 'post', 'class' => 'btn btn-default btn-flat']
                                )
                                ?>
                            </div>
                        </li>
                    </ul>
                </li>
                <!-- User Account: style can be found in dropdown.less -->
            </ul>
        </div>
    </nav>
</header>
