<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use kartik\select2\Select2;
use app\models\Usuarios;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $model app\models\Proyecciones */
/* @var $form yii\widgets\ActiveForm */
$anios = $model->getListAnios();
$meses = $model->getListMeses();

if(empty($model->meta_compras))
    $model->meta_compras = 0;
if(empty($model->meta_ventas))
    $model->meta_ventas = 0;
?>

<div class="proyecciones-form box box-primary">
    <div class="box-body">
        <br/>
    <?php $form = ActiveForm::begin(['layout' => 'horizontal']); ?>

    <?= $form->field($model, 'anio')->dropDownList($anios
                    , ['prompt' => "Seleccione..."]); ?>

    <?= $form->field($model, 'mes')->dropDownList($meses
                    , ['prompt' => "Seleccione..."]); ?>

    <?= $form->field($model, 'meta_compras')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'meta_ventas')->textInput(['maxlength' => true]) ?>    
                         
    <?php
        if(\Yii::$app->user->identity->isSuperAdmin()){
            $listUs = Usuarios::find()->all();                    
            $usuarios = ArrayHelper::map($listUs, 'id', 'nombre');
            echo $form->field($model, 'usuario_id')->widget(Select2::classname(), [        
                'data' => $usuarios,
                'options' => ['placeholder' => 'Seleccione ...'],
                'pluginOptions' => [
                    'allowClear' => true
                ],
            ]);
        }
    ?>

    <hr>
        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-primary' : 'btn btn-primary']) ?>
                <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>
    </div>

    <?php ActiveForm::end(); ?>

    </div>
</div>
