<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ProyeccionesSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Proyecciones');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="proyecciones-index box box-primary">
    
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Create Proyecciones'), ['create'], ['class' => 'btn btn-primary']) ?>
        </p>
    </div>  
    <div class="box-body">
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            //['class' => 'yii\grid\SerialColumn'],
            'id',
            'anio',                                                            
            'mes',                                                            
            [
                'attribute'=>'meta_compras',
                'value'=> function($data){
                    return number_format($data->meta_compras);
                },
            ],                        
            [
                'attribute'=>'meta_ventas',
                'value'=> function($data){
                    return number_format($data->meta_ventas);
                },
            ],
            [
                'attribute'=>'nomUsuario',
                'value'=>'usuario.nombre'
            ],            
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>
