<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Proyecciones */

$this->title = $model->usuario->nombre;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Proyecciones'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="proyecciones-view box box-primary">    
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </p>
    </div>
    <div class="box-body">

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'anio',                 
            'mes',                 
            [
                'attribute'=>'meta_compras',
                'value'=>'$ '.number_format($model->meta_compras)
            ],
            [
                'attribute'=>'meta_ventas',
                'value'=>'$ '.number_format($model->meta_ventas)
            ],            
            'usuario.nombre',
        ],
    ]) ?>

    </div>
</div>
