<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use app\models\Proveedores;
use app\models\Distribuidores;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $model app\models\Referencias */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="referencias-form box box-primary">
    <div class="box-body">
        <br>
        <?php $form = ActiveForm::begin(['layout' => 'horizontal']); ?>

        <?= $form->field($model, 'ref_proveedor')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'ref_descripcion_proveedor')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'categoria_proveedor')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'ref_distribuidor')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'ref_descripcion_distribuidor')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'categoria_distribuidor')->textInput(['maxlength' => true]) ?>        

       <?php
        if (\Yii::$app->user->identity->isSuperAdmin()){
            //Listado proveedores ----------------------------------------------
            $branchOffice = Yii::$app->runAction('usr-branch-office/get-branch-user');

            if(empty($branchOffice['providers']) == false){
                $proveedores = Proveedores::find()->where(['in', 'id', $branchOffice['providers']])->all();
            }else{
                $proveedores = Proveedores::find()->all();
            }
            $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
            echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                    , ['prompt' => "Seleccione..."]);
            //Listado distribuidores -------------------------------------------
            $distribuidores = Distribuidores::find()->all();
            $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
            echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                    , ['prompt' => "Seleccione..."]);
        }elseif (\Yii::$app->user->identity->isProveedor()){
            //Listado distribuidores -------------------------------------------
            $distribuidores = Distribuidores::find()->all();
            $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
            echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                    , ['prompt' => "Seleccione..."]);
            
            $idProveedor = Yii::$app->user->identity->getIdProveedor();
            if(!empty($idProveedor)){
                echo $form->field($model, 'proveedor_id')->hiddenInput(
                    ['value' => $idProveedor])->label(false);
            }else{
                if(empty($branchOffice['providers']) == false){
                    $proveedores = Proveedores::find()->where(['in', 'id', $branchOffice['providers']])->all();
                }else{
                    $proveedores = Proveedores::find()->all();
                }

                $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');
                echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                        , ['prompt' => "Seleccione..."]);
            }            
        }elseif (\Yii::$app->user->identity->isDistribuidor()){
            //Listado distribuidores -------------------------------------------
            $branchOffice = Yii::$app->runAction('usr-branch-office/get-branch-user');

            if(empty($branchOffice['providers']) == false){
                $proveedores = Proveedores::find()->where(['in', 'id', $branchOffice['providers']])->all();
            }else{
                $proveedores = Proveedores::find()->all();
            }

            $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
            echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                    , ['prompt' => "Seleccione..."]);
            
            $idDistribuidor = Yii::$app->user->identity->getIdDistribuidor();
            if(!empty($idDistribuidor)){
                echo $form->field($model, 'distribuidor_id')->hiddenInput(
                    ['value' => $idDistribuidor]);
            }else{
                $distribuidores = Distribuidores::find()->all();
                $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
                echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                        , ['prompt' => "Seleccione..."]);                                
            }            
        }
        ?>     

        <hr>
        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-primary' : 'btn btn-primary']) ?>
                <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>
