<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use kartik\file\FileInput;
use kartik\export\ExportMenu;
use yii\data\ArrayDataProvider;
use app\models\Proveedores;
use app\models\Distribuidores;
use yii\helpers\ArrayHelper;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
$this->title = Yii::t('app', 'load_file_ref');
$this->params['breadcrumbs'][] = $this->title;
?>

<div class="machine-index box box-primary">    
    <div class="box-body">
        <br>        
        <?php $form = ActiveForm::begin(['options' => ['enctype' => 'multipart/form-data'], 'layout' => 'horizontal']); ?>
        
        <?php
        if (\Yii::$app->user->identity->isSuperAdmin()){
            //Listado proveedores ----------------------------------------------
            $proveedores = Proveedores::find()->all();
            $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
            echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                    , ['prompt' => "Seleccione..."]);
            //Listado distribuidores -------------------------------------------
            $distribuidores = Distribuidores::find()->all();
            $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
            echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                    , ['prompt' => "Seleccione..."]);
        }elseif (\Yii::$app->user->identity->isProveedor()){
            $idProveedor = Yii::$app->user->identity->getIdProveedor();
            if(!empty($idProveedor)){
                echo $form->field($model, 'proveedor_id')->hiddenInput(
                    ['value' => $idProveedor])->label(false);
            }else{
                $proveedores = Proveedores::find()->all();
                $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
                echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                        , ['prompt' => "Seleccione..."]);
            }
            //Listado distribuidores -------------------------------------------
            $distribuidores = Distribuidores::find()->all();
            $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
            echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                    , ['prompt' => "Seleccione..."]);
        }elseif (\Yii::$app->user->identity->isDistribuidor()){
            $idDistribuidor = Yii::$app->user->identity->getIdDistribuidor();
            if(!empty($idDistribuidor)){
                echo $form->field($model, 'distribuidor_id')->hiddenInput(
                    ['value' => $idDistribuidor]);
            }else{
                $distribuidores = Distribuidores::find()->all();
                $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
                echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                        , ['prompt' => "Seleccione..."]);                                
            }
            //Listado distribuidores -------------------------------------------
            $proveedores = Proveedores::find()->all();
            $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
            echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                    , ['prompt' => "Seleccione..."]);
        }
        ?>
        
        <div class="form-group">            
            <div class="col-lg-12">
            <?=
            $form->field($model, 'fileInput')->widget(FileInput::classname(), [
                'options' => ['accept' => 'file/*', 'class'=>'form-control'],
                'pluginOptions' => ['allowedFileExtensions' => ['xlsx'],
                    'maxFileSize' => 25000
            ]]);
            ?>            
            </div>        
        </div>                         
        <hr> 
        <div class="form-group">
            <div class="col-lg-offset-2 col-lg-11">
                <?= Html::submitButton(Yii::t('app', 'Load'), ['class' => 'btn btn-primary']) ?>
                <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
            </div>
        </div>
        <?php ActiveForm::end(); ?>        
        <div class="form-group col-lg-offset-2">
            <?php 
            $nameFile = 'Ejemplo_carga_referencias';
            $columns = Yii::$app->params["columnas_ejemplo_export"];

            $data = [[
                'ref_proveedor' => '4090',
                'ref_descripcion_proveedor' => 'Aderezo de Tomate Fruco Bolsax1000gr',
                'categoria_proveedor' => 'BUC',
                'ref_distribuidor' => '1001',
                'ref_descripcion_distribuidor' => 'Aderezo de Tomate Fruco Bolsax1000gr',
                'categoria_distribuidor' => 'salsas', 
            ]];                
            ?>
            <?php
            echo ExportMenu::widget([
                'dataProvider' => new ArrayDataProvider(['allModels' => $data]),
                'columns' => $columns,
                'columnSelectorOptions' => [
                    'label' => Yii::t('app', 'Columns'),
                ],
                'dropdownOptions' => [
                    'label' => Yii::t('app', 'Exportar Ejemplo Estructura'),
                    'class' => 'btn btn-success'
                ],        
                'showColumnSelector' => false,
                'showConfirmAlert' => false,
                'target' => '_blank',
                'filename' => $nameFile,
                'exportRequestParam' => 'ejemplo_archivo_referencias',
                'exportConfig' => [
                    ExportMenu::FORMAT_EXCEL => false,
                    ExportMenu::FORMAT_CSV => false,
                    ExportMenu::FORMAT_TEXT => false,
                    ExportMenu::FORMAT_PDF => false,
                    ExportMenu::FORMAT_HTML => false,
                ]
            ]);
            ?>                    
        </div>        
    </div>
</div>

