<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Referencias */

$this->title = $model->ref_proveedor;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Referencias'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="referencias-view box box-primary">    
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </p>
    </div>
    <div class="box-body">

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'ref_proveedor',
            'ref_descripcion_proveedor',
            'categoria_proveedor',
            'ref_distribuidor',
            'ref_descripcion_distribuidor',
            'categoria_distribuidor',
            'distribuidor.razon_social',
            'proveedor.razon_social',
        ],
    ]) ?>

    </div>
</div>
