<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use app\assets\PuglinsAsset;
use yii\helpers\ArrayHelper;
use app\models\Proyecciones;
use app\components\Util;
use app\models\Usuarios;
use yii\helpers\Url;
use app\models\Proveedores;


/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \common\models\LoginForm */

//------------------------------------------------------------------------------
PuglinsAsset::register($this);
//Grafica ventas ---------------------------------------------------------------
$anioAnt = date('Y')-1;
$anio = date('Y');
$mesesCompras = '';
$dataGrafCompras = '';
$dataGrafComprasAn = '';
if(count($comprasInfo['meses_grafica'])>0){
    $mesesCompras = '"'.implode('","', $comprasInfo['meses_grafica'][$anio]).'"';
}
if(count($comprasInfo['totales_grafica'])>0){
    $dataGrafComprasAn = implode(',', $comprasInfo['totales_grafica'][$anioAnt]);
    $dataGrafCompras = implode(',', $comprasInfo['totales_grafica'][$anio]);
} 
?>

<div class="box-body">
    <div class="row">
        <div class="col-md-9 border-right border-">
            <div class="chart">
                <canvas id="comprasChart" style="height:250px"></canvas>                        
            </div>
        </div>                    
        <div class="col-md-3 text-center">
            <p><strong><?= Yii::t('app', 'Info grafica') ?></strong></p>
            <div id="legend-compras"></div>
            <p>
                <strong><?= Yii::t('app', 'Mayor Compra Ultimos meses') ?>: <?= $anio ?></strong>
            </p>
            <div>$ <?= isset($comprasInfo['totales_grafica'][$anio]) ? 
            number_format(max($comprasInfo['totales_grafica'][$anio])): 0 ?></div>
            <br/>
            <p>
                <strong><?= Yii::t('app', 'Mayor Compra Ultimos meses') ?>: <?= $anioAnt ?></strong>
            </p>                
            <div>$ <?= isset($comprasInfo['totales_grafica'][$anioAnt])? 
            number_format(max($comprasInfo['totales_grafica'][$anioAnt])): 0 ?></div>
        </div>                    
    </div>                    
</div>                    
<div class="box-footer">
    <div class="row text-center"><h3><?= Yii::t('app', 'Info Meta') ?></h3></div>
    <?php if(count($comprasInfo['meses_grafica'])>0):
        foreach ($comprasInfo['meses_grafica'] as $KeyAnio => $data) : ?>
        <div class="col-md-6 border-right">            
            <p class="text-center">
                <strong><?= Yii::t('app', 'Anio').': '.$KeyAnio ?></strong>
            </p>
            <?php                         
            foreach ($data as $key => $value) :                                                                          
            $porcentaje = $porcentajeDif = 0;                     
            if(isset($comprasInfo['proyecciones'][$KeyAnio][$value]) 
                    && $comprasInfo['proyecciones'][$KeyAnio][$value]['meta_compras'] > 0){
                $metaVentas = (int)$comprasInfo['proyecciones'][$KeyAnio][$value]['meta_compras'];
            }else{
                $metaVentas =  max($comprasInfo['totales_grafica'][$KeyAnio]); 
            }

            if($comprasInfo['totales_grafica'][$KeyAnio][$key] >0){
                $porcentaje = (($comprasInfo['totales_grafica'][$KeyAnio][$key])*100)/$metaVentas;
                $resta = $comprasInfo['totales_grafica'][$KeyAnio][$key] - $metaVentas;                    
                $porcentajeDif = number_format(($resta*100)/$metaVentas,2);
            }                
            $classProg = Util::getClassProgress($porcentaje);                
            ?>                    
            <div class="row">
                <div class="col-sm-8">
                    <div class="progress-group">
                        <span class="progress-text"><?= $value ?></span>
                        <span class="progress-number">
                            <b>$<?= number_format($comprasInfo['totales_grafica'][$KeyAnio][$key]) ?>
                            </b>/$<?= number_format($metaVentas) ?></span>
                        <div class="progress sm">
                          <div class="progress-bar <?= $classProg ?>" style="width: <?= $porcentaje ?>%"></div>
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="description-block">
                      <?php if($porcentajeDif>0): ?>  
                        <span class="description-percentage text-green"><i class="fa fa-caret-up"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php elseif($porcentajeDif < 0): ?>                                
                        <span class="description-percentage text-red"><i class="fa fa-caret-down"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php else: ?>
                        <span class="description-percentage text-yellow"><i class="fa fa-caret-left"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php endif; ?>                          
                    </div>                  
                </div>                       
            </div>
    <?php endforeach; ?>
    </div>        
    <?php endforeach; ?>
    <div class="row">
        <div class="col-sm-12">
            <hr>
        </div>                
    </div>
    <div class="row">
        <div class="col-sm-6 border-right">                
            <p class="text-center">
                <strong><?= Yii::t('app', 'Tabla de Crecimiento Mensual') ?></strong>
            </p>                
            <table class="table table-striped">
                <tr>
                    <th><?= Yii::t('app', 'Mes') ?></th>
                    <th><?= $anioAnt ?></th>
                    <th><?= $anio ?></th>
                    <th><?= Yii::t('app', 'Crecimiento') ?></th>
                </tr>                    
            <?php foreach ($comprasInfo['meses_grafica'][$anio] as $keyMes => $data) : 
                    $porCrecimineto =  0;
                    $compraMesAnioAnt = empty($comprasInfo['totales_grafica'][$anioAnt][$keyMes]) == false ? $comprasInfo['totales_grafica'][$anioAnt][$keyMes] : null;
                    $compraMesAnio = $comprasInfo['totales_grafica'][$anio][$keyMes];
                    if(isset($comprasInfo['totales_grafica'][$anioAnt][$keyMes]) 
                        && $comprasInfo['totales_grafica'][$anioAnt][$keyMes] >0){                            
                        $porCrecimineto = ((($compraMesAnio)*100)/$compraMesAnioAnt-100);                            
                    }                            
                ?>
                <tr>
                    <td><strong><?= $data ?></strong></td>                           
                    <td>$<?= number_format($compraMesAnioAnt) ?></td>
                    <td>$<?= number_format($compraMesAnio) ?></td>
                    <td>
                        <?php if($porCrecimineto > 0): ?>  
                        <span class="description-percentage text-green">
                            <i class="fa fa-caret-up"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php elseif($porCrecimineto < 0): ?>                                
                        <span class="description-percentage text-red">
                            <i class="fa fa-caret-down"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php else: ?>
                        <span class="description-percentage text-yellow">
                            <i class="fa fa-caret-left"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php endif; ?>
                    </td>
                </tr>
            <?php endforeach; ?>  
            </table>                
        </div>
        <div class="col-sm-6">
            <p class="text-center">
                <strong><?= Yii::t('app', 'Proyeccion Crecimiento Trimestral') ?></strong>
                <?php
                    $trimestre = Util::getTrimestre();
                    $proyecciones = [];
                    if(is_null($idProveedor)){
                        $proyecciones = Proyecciones::find()->where(
                            'usuario_id = '.Yii::$app->user->identity->id
                            .' AND mes in("'.  implode('","', $trimestre).'")' )->asArray()->all();            
                    }else{
                        $usuario = Usuarios::findOne(['proveedor_id'=>$idProveedor]);
                        if(!is_null($usuario)){
                            $proyecciones = Proyecciones::find()
                                ->where('usuario_id = '.$usuario->id
                            .' AND mes in("'.  implode('","', $trimestre).'")' )->asArray()->all();            
                        }            
                    }
                    $proyTrimestral = 0;                                                                                      
                    $arrayProyecciones = ArrayHelper::map($proyecciones, 'mes', 'meta_compras');                        
                ?>

                <table class="table table-striped">
                    <tr>
                        <th></th>                            
                        <th><?= Yii::t('app', 'Trimestre') ?></th>                            
                        <?php foreach ($trimestre as $value): ?>
                        <th><?= $value ?></th>    
                        <?php endforeach;?>
                        <th><?= Yii::t('app', 'Total') ?></th>
                    </tr> 
                    <tr>
                        <td><strong><?= Yii::t('app', 'Proyeccion') ?></strong></td>   
                        <td><?= floor((date('m')-1) / 3)+1 ?></td>   
                        <?php 
                            $sumaTrim = 0;                                 
                            foreach ($trimestre as $value): 
                                $valor = isset($arrayProyecciones[$value]) ? $arrayProyecciones[$value] : 0;
                                $sumaTrim += $valor;
                        ?>
                        <td>$<?= number_format($valor) ?></td>    
                        <?php endforeach;?>
                        <td>$<?= number_format($sumaTrim)?></td>
                    </tr>
                    <tr>
                        <td><strong><?= Yii::t('app', 'Estado Actual') ?></strong></td>   
                        <td><?= floor((date('m')-1) / 3)+1 ?></td>   
                        <?php                                 
                            $comprasTrim = 0;
                            foreach ($trimestre as $value):                                    
                                $keyMesTrim = array_search($value, $comprasInfo['meses_grafica'][$anio]);                                    
                                $valor = 0;
                                if(!empty($keyMesTrim)){
                                    $valor = $comprasInfo['totales_grafica'][$anio][$keyMesTrim];                                        
                                }                                                                                                   
                                $comprasTrim = $comprasTrim + $valor;
                        ?>
                        <td>$<?= number_format($valor) ?></td>    
                        <?php endforeach;?>
                        <td>$<?= number_format($comprasTrim)?></td>
                    </tr>
                </table>
                <?php 
                $porcentajeTrim = 0;    
                if($sumaTrim > 0){
                    $porcentajeTrim = ($comprasTrim*100)/$sumaTrim;
                }                                        
                $classProg = Util::getClassProgress($porcentajeTrim);
                ?>
                <div class="progress-group">
                    <span class="progress-text"><?= Yii::t('app', 'Ventas').': '
                        .implode(', ', $trimestre) ?></span>
                    <span class="progress-number">
                        <b>$<?= number_format($comprasTrim) ?>
                        </b>/$<?= number_format($sumaTrim) ?></span>
                    <div class="progress sm">
                      <div class="progress-bar <?= $classProg ?>" style="width: <?= $porcentajeTrim ?>%"></div>
                    </div>
                </div>
            </p>
        </div>
    </div>
<?php endif; ?>                         
</div>
<script>
$(function () {    
    //Grafica de compras -------------------------------------------------------
    var areaChartCanvas = $("#comprasChart").get(0).getContext("2d");    
    var areaChart = new Chart(areaChartCanvas);
    var areaChartData = {
      labels: [<?= $mesesCompras ?>],
      datasets: [
        {
          label: "<?= Yii::t('app', 'Compras').': '.$anioAnt ?>",
          fillColor: "rgba(210,214,222,0.4)",          
          strokeColor: "rgba(210,214,222,0.8)",
          pointColor: "#D2D6DE",
          pointStrokeColor: "rgba(210,214,222,1)",
          pointHighlightFill: "#fff",
          pointHighlightStroke: "rgba(210,214,222,1)",
          data: [<?= $dataGrafComprasAn ?>]
        },
        {
          label: "<?= Yii::t('app', 'Compras').': '.$anio ?>",
          fillColor: "rgba(0, 133, 72, 0.4)",
          strokeColor: "rgba(0, 133, 72, 1)",
          pointColor: "rgba(0, 133, 72, 1)",
          pointStrokeColor: "#008d4d",
          pointHighlightFill: "#fff",
          pointHighlightStroke: "rgba(0, 133, 72,1)",
          data: [<?= $dataGrafCompras ?>]
        }
      ]
    };

    var areaChartOptions = {
      showScale: true,      
      scaleShowGridLines: false,
      scaleGridLineColor: "rgba(0,0,0,.05)",
      scaleGridLineWidth: 1,      
      scaleShowHorizontalLines: true,      
      scaleShowVerticalLines: true,      
      bezierCurve: true,      
      bezierCurveTension: 0.05,      
      pointDot: true,
      pointDotRadius: 4,
      pointDotStrokeWidth: 1,     
      pointHitDetectionRadius: 20,
      datasetStroke: true,      
      datasetStrokeWidth: 2,      
      datasetFill: true,            
      legendTemplate : '<ul>'
                  +'<% for (var i=0; i<datasets.length; i++) { %>'
                    +'<li style="list-style:none">'
                    +'<span style=\"-moz-border-radius:1px; border-radius:1px; margin-right:10px;width:15px;height:15px;display:inline-block;background-color:<%=datasets[i].fillColor%>\"> </span>'
                    +'<% if (datasets[i].label) { %><%= datasets[i].label %><% } %>'
                  +'</li>'
                +'<% } %>'
              +'</ul>',
      maintainAspectRatio: true,       
      responsive: true,
      scaleLabel : function (label) {
        return "    $" + label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
      },
//      tooltipTemplate : function (label) {
//        return label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
//      },
    multiTooltipTemplate : function (label) {
    return label.datasetLabel + ': ' +  "$" +  label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
   },
      tooltips: {
        callbacks: {
            label: function(tooltipItem, data) {
                return "$" + Number(tooltipItem.yLabel).toFixed(0).replace(/./g, function(c, i, a) {
                    return i > 0 && c !== "." && (a.length - i) % 3 === 0 ? "," + c : c;
                });
            }
        }
    }
    };

    var lineChart = areaChart.Line(areaChartData, areaChartOptions);    
    $("#legend-compras").html(lineChart.generateLegend());    
  });
</script>

