<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use app\assets\PuglinsAsset;
use yii\helpers\ArrayHelper;
use app\models\Proyecciones;
use app\components\Util;
use app\models\Usuarios;
use yii\helpers\Url;
use app\models\Proveedores;


/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \common\models\LoginForm */

//------------------------------------------------------------------------------
PuglinsAsset::register($this);
//Grafica ventas ---------------------------------------------------------------
$anioAnt = date('Y')-1;
$anio = date('Y');
$mesesVentas = '';
$dataGrafVentas = '';
$dataGrafVentasAnt = '';
if(count($ventasInfo['meses_grafica'])>0){
    $mesesVentas = '"'.implode('","', $ventasInfo['meses_grafica'][$anio]).'"';
}
if(count($ventasInfo['totales_grafica'])>0){
    if(empty($ventasInfo['totales_grafica'][$anioAnt]) == false){
        $dataGrafVentasAnt = implode(',', $ventasInfo['totales_grafica'][$anioAnt]);
    }

    if(empty($ventasInfo['totales_grafica'][$anio]) == false){
        $dataGrafVentas = implode(',', $ventasInfo['totales_grafica'][$anio]);
    }
}
?>

<div class="box-body">
    <div class="row">
        <div class="col-md-9 border-right border-">
            <div class="chart">
                <canvas id="ventasChart" style="height:250px"></canvas>                        
            </div>
        </div>                    
        <div class="col-md-3 text-center">
            <p><strong><?= Yii::t('app', 'Info grafica') ?></strong></p>
            <div id="legend-ventas"></div>
            <p>
                <strong><?= Yii::t('app', 'Mayor Venta Ultimos meses') ?>: <?= $anio ?></strong>
            </p>
            <div>$ <?= (isset($ventasInfo['totales_grafica'][$anio])) ?
            number_format(max($ventasInfo['totales_grafica'][$anio])) : 0 ?></div>
            <br/>
            <p>
                <strong><?= Yii::t('app', 'Mayor Venta Ultimos meses') ?>: <?= $anioAnt ?></strong>
            </p>                
            <div>$ <?= isset($ventasInfo['totales_grafica'][$anioAnt]) 
            ? number_format(max($ventasInfo['totales_grafica'][$anioAnt])) : 0 ?></div>
        </div>                    
    </div>                    
</div>                    
<div class="box-footer">
    <div class="row text-center"><h3><?= Yii::t('app', 'Info Meta') ?></h3></div>
    <?php if(count($ventasInfo['meses_grafica'])>0):
        foreach ($ventasInfo['meses_grafica'] as $KeyAnio => $data) : ?>
        <div class="col-md-6 border-right">            
            <p class="text-center">
                <strong><?= Yii::t('app', 'Anio').': '.$KeyAnio ?></strong>
            </p>
            <?php                         
            foreach ($data as $key => $value) :                                                                          
            $porcentaje = $porcentajeDif = 0;                     
            if(isset($ventasInfo['proyecciones'][$KeyAnio][$value]) 
                    && $ventasInfo['proyecciones'][$KeyAnio][$value]['meta_ventas'] > 0){
                $metaVentas = (int)$ventasInfo['proyecciones'][$KeyAnio][$value]['meta_ventas'];
            }else{
                $metaVentas =  max($ventasInfo['totales_grafica'][$KeyAnio]); 
            }

            if($ventasInfo['totales_grafica'][$KeyAnio][$key] >0){
                $porcentaje = (($ventasInfo['totales_grafica'][$KeyAnio][$key])*100)/$metaVentas;
                $resta = $ventasInfo['totales_grafica'][$KeyAnio][$key] - $metaVentas;                    
                $porcentajeDif = number_format(($resta*100)/$metaVentas,2);
            }

            $classProg = Util::getClassProgress($porcentaje);                        
            ?>                    
            <div class="row">
                <div class="col-sm-8">
                    <div class="progress-group">
                        <span class="progress-text"><?= $value ?></span>
                        <span class="progress-number">
                            <b>$<?= number_format($ventasInfo['totales_grafica'][$KeyAnio][$key]) ?>
                            </b>/$<?= number_format($metaVentas) ?></span>
                        <div class="progress sm">
                          <div class="progress-bar <?= $classProg ?>" style="width: <?= $porcentaje ?>%"></div>
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="description-block">
                      <?php if($porcentajeDif>0): ?>  
                        <span class="description-percentage text-green"><i class="fa fa-caret-up"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php elseif($porcentajeDif < 0): ?>                                
                        <span class="description-percentage text-red"><i class="fa fa-caret-down"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php else: ?>
                        <span class="description-percentage text-yellow"><i class="fa fa-caret-left"></i> <?= $porcentajeDif?>% </span>($<?= number_format($resta) ?>)
                      <?php endif; ?>                          
                    </div>                  
                </div>                       
            </div>
    <?php endforeach; ?>
    </div>                                
    <?php endforeach; ?>          
    <div class="row">
        <div class="col-sm-12">
            <hr>
        </div>                
    </div>
    <div class="row">
        <div class="col-sm-6 border-right">                
            <p class="text-center">
                <strong><?= Yii::t('app', 'Tabla de Crecimiento Mensual') ?></strong>
            </p>                
            <table class="table table-striped">
                <tr>
                    <th><?= Yii::t('app', 'Mes') ?></th>
                    <th><?= $anioAnt ?></th>
                    <th><?= $anio ?></th>
                    <th><?= Yii::t('app', 'Crecimiento') ?></th>
                </tr>
            <?php foreach ($ventasInfo['meses_grafica'][$anio] as $keyMes => $data) :
                    $porCrecimineto =  0;
                    $ventaMesAnioAnt = empty($ventasInfo['totales_grafica'][$anioAnt][$keyMes]) == false ? $ventasInfo['totales_grafica'][$anioAnt][$keyMes] : 0;
                    $ventaMesAnio = empty($ventasInfo['totales_grafica'][$anio][$keyMes])  == false ? $ventasInfo['totales_grafica'][$anio][$keyMes] : 0;
                    if(isset($ventasInfo['totales_grafica'][$anioAnt][$keyMes]) 
                        && $ventasInfo['totales_grafica'][$anioAnt][$keyMes] >0){                            
                        $porCrecimineto = ((($ventaMesAnio)*100)/$ventaMesAnioAnt-100);                            
                    }                            
                ?>
                <tr>
                    <td><strong><?= $data ?></strong></td>                           
                    <td>$<?= number_format($ventaMesAnioAnt) ?></td>
                    <td>$<?= number_format($ventaMesAnio) ?></td>
                    <td>
                        <?php if($porCrecimineto > 0): ?>  
                        <span class="description-percentage text-green">
                            <i class="fa fa-caret-up"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php elseif($porCrecimineto < 0): ?>                                
                        <span class="description-percentage text-red">
                            <i class="fa fa-caret-down"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php else: ?>
                        <span class="description-percentage text-yellow">
                            <i class="fa fa-caret-left"></i> 
                            <?= number_format($porCrecimineto, 2)?>% 
                        </span>
                      <?php endif; ?>
                    </td>
                </tr>
            <?php endforeach; ?>
            </table>                
        </div>
        <div class="col-sm-6">
            <p class="text-center">
                <strong><?= Yii::t('app', 'Proyeccion Crecimiento Trimestral') ?></strong>
                <?php
                    $trimestre = Util::getTrimestre();
                    $proyecciones = [];
                    if(is_null($idProveedor)){
                        $proyecciones = Proyecciones::find()->where(
                            'usuario_id = '.Yii::$app->user->identity->id
                            .' AND mes in("'.  implode('","', $trimestre).'")' )->asArray()->all();            
                    }else{
                        $usuario = Usuarios::findOne(['proveedor_id'=>$idProveedor]);
                        if(!is_null($usuario)){
                            $proyecciones = Proyecciones::find()
                                ->where('usuario_id = '.$usuario->id
                            .' AND mes in("'.  implode('","', $trimestre).'")' )->asArray()->all();            
                        }            
                    }
                    $proyTrimestral = 0;                                                                                      
                    $arrayProyecciones = ArrayHelper::map($proyecciones, 'mes', 'meta_ventas');                        
                ?>

                <table class="table table-striped">
                    <tr>
                        <th></th>                            
                        <th><?= Yii::t('app', 'Trimestre') ?></th>                            
                        <?php foreach ($trimestre as $value): ?>
                        <th><?= $value ?></th>    
                        <?php endforeach;?>
                        <th><?= Yii::t('app', 'Total') ?></th>
                    </tr> 
                    <tr>
                        <td><strong><?= Yii::t('app', 'Proyeccion') ?></strong></td>   
                        <td><?= floor((date('m')-1) / 3)+1 ?></td>   
                        <?php 
                            $sumaTrim = 0;                                 
                            foreach ($trimestre as $value): 
                                $valor = isset($arrayProyecciones[$value]) ? $arrayProyecciones[$value] : 0;
                                $sumaTrim += $valor;
                        ?>
                        <td>$<?= number_format($valor) ?></td>    
                        <?php endforeach;?>
                        <td>$<?= number_format($sumaTrim)?></td>
                    </tr>
                    <tr>
                        <td><strong><?= Yii::t('app', 'Estado Actual') ?></strong></td>   
                        <td><?= floor((date('m')-1) / 3)+1 ?></td>   
                        <?php                                 
                            $ventasTrim = 0;
                            foreach ($trimestre as $value):                                    
                                $keyMesTrim = array_search($value, $ventasInfo['meses_grafica'][$anio]);                                    
                                $valor = 0;
                                if(!empty($keyMesTrim)){
                                    $valor = $ventasInfo['totales_grafica'][$anio][$keyMesTrim];                                        
                                }                                                                                                   
                                $ventasTrim = $ventasTrim + $valor;
                        ?>
                        <td>$<?= number_format($valor) ?></td>    
                        <?php endforeach;?>
                        <td>$<?= number_format($ventasTrim)?></td>
                    </tr>
                </table>
                <?php 
                $porcentajeTrim = 0;    
                if($sumaTrim > 0){
                    $porcentajeTrim = ($ventasTrim*100)/$sumaTrim;
                }                                        
                $classProg = Util::getClassProgress($porcentajeTrim);
                ?>
                <div class="progress-group">
                    <span class="progress-text"><?= Yii::t('app', 'Ventas').': '
                        .implode(', ', $trimestre) ?></span>
                    <span class="progress-number">
                        <b>$<?= number_format($ventasTrim) ?>
                        </b>/$<?= number_format($sumaTrim) ?></span>
                    <div class="progress sm">
                      <div class="progress-bar <?= $classProg ?>" style="width: <?= $porcentajeTrim ?>%"></div>
                    </div>
                </div>
            </p>
        </div>
    </div>
<?php endif; ?>                         
</div>
<script>

$(function () {    
    //Grafica de ventas --------------------------------------------------------
    var areaChartCanvas = $("#ventasChart").get(0).getContext("2d");    
    var areaChart = new Chart(areaChartCanvas);
    var areaChartData = {
      labels: [<?= $mesesVentas ?>],
      options: {legend:{display:true,legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<datasets.length; i++){%><li><span style=\"background-color:<%=datasets[i].lineColor%>\"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>",      }}, 
      datasets: [
        {
          label: "<?= Yii::t('app', 'Ventas').': '.$anioAnt ?>",
          fillColor: "rgba(210,214,222,0.5)",          
          strokeColor: "rgba(210,214,222,0.9)",
          lineColor: "#D2D6DE",
          pointColor: "#D2D6DE",
          pointStrokeColor: "rgba(210,214,222,1)",
          pointHighlightFill: "#fff",
          pointHighlightStroke: "rgba(210,214,222,1)",
          data: [<?= $dataGrafVentasAnt ?>]
        },
        {
          label: "<?= Yii::t('app', 'Ventas').': '.$anio ?>",
          fillColor: "rgba(60,141,188,0.5)",          
          strokeColor: "rgba(60,141,188,0.9)",
          pointColor: "#3b8bba",
          pointStrokeColor: "rgba(60,141,188,1)",
          pointHighlightFill: "#fff",
          pointHighlightStroke: "rgba(60,141,188,1)",
          data: [<?= $dataGrafVentas ?>]
        }
      ]
    };

    var areaChartOptions = {
      showScale: true,      
      scaleShowGridLines: false,
      scaleGridLineColor: "rgba(0,0,0,.05)",
      scaleGridLineWidth: 1,      
      scaleShowHorizontalLines: true,      
      scaleShowVerticalLines: true,      
      bezierCurve: true,      
      bezierCurveTension: 0.05,      
      pointDot: true,
      pointDotRadius: 4,
      pointDotStrokeWidth: 1,     
      pointHitDetectionRadius: 20,
      datasetStroke: true,      
      datasetStrokeWidth: 2,      
      datasetFill: true,            
      legendTemplate : '<ul>'
                  +'<% for (var i=0; i<datasets.length; i++) { %>'
                    +'<li style="list-style:none">'
                    +'<span style=\"-moz-border-radius:1px; border-radius:1px; margin-right:10px;width:15px;height:15px;display:inline-block;background-color:<%=datasets[i].fillColor%>\"> </span>'
                    +'<% if (datasets[i].label) { %><%= datasets[i].label %><% } %>'
                  +'</li>'
                +'<% } %>'
              +'</ul>',
      maintainAspectRatio: true,      
      responsive: true,
      scaleLabel : function (label) {
        return "    $" + label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
      },
//      tooltipTemplate : function (label) {
//        return label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
//      },
        multiTooltipTemplate : function (label) {
        return label.datasetLabel + ': ' +  "$" + label.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
       },
        tooltips: {
          callbacks: {
              label: function(tooltipItem, data) {
                  return "$" + Number(tooltipItem.yLabel).toFixed(0).replace(/./g, function(c, i, a) {
                      return i > 0 && c !== "." && (a.length - i) % 3 === 0 ? "," + c : c;
                  });
              }
          }
      }
    };
    
    var lineChart = areaChart.Line(areaChartData, areaChartOptions);    
    $("#legend-ventas").html(lineChart.generateLegend()); 
  });
</script>

