<?php

use yii\helpers\Html;
use app\assets\PuglinsAsset;
use yii\bootstrap\ActiveForm;
use app\models\Proveedores;
use kartik\select2\Select2;
use yii\helpers\ArrayHelper;
use app\models\Proyecciones;
use app\components\Util;
use app\models\Usuarios;
use yii\helpers\Url;

/* @var $this yii\web\View */
if (\Yii::$app->user->identity->isSuperAdmin()){
    if(empty($branchOffice['providers']) == false){
        $peoveedores = ArrayHelper::map(Proveedores::find()->where(['in', 'id', $branchOffice['providers']])->all(), 'id', 'razon_social');
    }else{
        $peoveedores = ArrayHelper::map(Proveedores::find()->all(), 'id', 'razon_social');
    }
}
$urlVentas = ['reportes/ventas'];
$urlCompras = ['reportes/compras'];
if(!is_null($idProveedor)){
    $this->title = 'Información General: '.$peoveedores[$idProveedor];
    $urlVentas = ['reportes/ventas', 'proveedor_id'=>$idProveedor];
    $urlCompras = ['reportes/compras', 'proveedor_id'=>$idProveedor];
}else{
    $this->title = 'Información General';
}
//------------------------------------------------------------------------------
PuglinsAsset::register($this);
//Grafica ventas ---------------------------------------------------------------
$anioAnt = date('Y')-1;
$anio = date('Y');
$mesesVentas = '';
?>

<?php if (\Yii::$app->user->identity->isSuperAdmin()): ?>
    <?php $form = ActiveForm::begin([
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => " <div class=\"form-group form-md-line-input\">{label}\n{beginWrapper}\n{input}<div class=\"form-control-focus\"> </div>\n{error}\n</div>{endWrapper}",
            'horizontalCssClasses' => [
                'label' => 'col-md-2 control-label',
                'offset' => 'col-sm-offset-4',
                'wrapper' => 'col-sm-10',
                'error' => 'has-error',
                'hint' => 'help-block',
            ],
        ],]); ?>
        <div class="box box-info collapsed-box">
            <div class="box-header with-border">
                <h3 class="box-title"><?= Yii::t('app', 'Proveedores') ?></h3>
                <div class="box-tools pull-right">
                    <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-plus"></i>
                    </button>
                </div>        
            </div>    
            <div class="box-body">   
                <div class="row">
                    <div class="col-lg-offset-2 col-sm-7 ">
                    <?php                     
                    echo $form->field($modelProv, 'id')->widget(Select2::classname(), [        
                            'data' => $peoveedores,
                            'options' => ['placeholder' => 'Seleccione ...'],
                            'pluginOptions' => [
                                'allowClear' => true
                            ],
                        ])->label('Proveedores');
                    ?>
                    </div>                    
                    <div class="col-sm-3">
                        <?= Html::submitButton(Yii::t('app', 'Buscar'), ['class' => 'btn btn-primary']) ?>                            
                    </div>                    
                </div>                                 
            </div>                                 
        </div>
    <?php ActiveForm::end(); ?>    
<?php endif; ?>

<div class="row">
    <div class="col-lg-3 col-xs-6">
      <!-- small box -->
      <div class="small-box bg-aqua">
        <div class="inner">
            <h3 id="totalVentaMes"></h3>
            <p><strong><?= Yii::t('app', 'Total Ventas Mes') ?><br>
            <?= Yii::t('app', 'Sell-Out') ?></strong></p>            
        </div>
        <div class="icon">
          <i class="fa fa-dollar"></i>
        </div>            
        <?= Html::a(Yii::t('app', 'mas info')
                ." <i class='fa fa-arrow-circle-right'></i>", 
            $urlVentas, ['class' => 'small-box-footer', 'target'=>'_blank']) ?>
      </div>
    </div>        
    <div class="col-lg-3 col-xs-6">
      <div class="small-box bg-green">
        <div class="inner">          
          <h3 id="totalCompraMes"></h3>
            <p><strong><?= Yii::t('app', 'Total Compras Mes') ?><br>
            <?= Yii::t('app', 'Sell-In') ?></strong></p>
        </div>
        <div class="icon">
          <i class="fa fa-credit-card"></i>
        </div>            
        <?= Html::a(Yii::t('app', 'mas info').
                " <i class='fa fa-arrow-circle-right'></i>", 
            $urlCompras, ['class' => 'small-box-footer', 'target'=>'_blank']) ?>
      </div>
    </div>        
    <div class="col-lg-3 col-xs-6">          
      <div class="small-box bg-yellow">
        <div class="inner">
            <h3 id="clienteMV"></h3>
            <p><div id="nomCliente">...<br></div>
               <strong><?= Yii::t('app', 'Cliente Mayor Venta') ?></strong></p>
        </div>
        <div class="icon">
          <i class="fa fa-user-plus"></i>
        </div>
        <?= Html::a(Yii::t('app', 'mas info')
                ." <i class='fa fa-arrow-circle-right'></i>", 
            $urlVentas, ['class' => 'small-box-footer', 'target'=>'_blank']) ?>
      </div>
    </div>        
    <div class="col-lg-3 col-xs-6">          
      <div class="small-box bg-red">
        <div class="inner">
            <h3 id="referenciaMV"></h3>
            <p><div id="nomReferencia">...<br></div>
               <strong><?= Yii::t('app', 'Referencia más vendida') ?></strong></p>
        </div>
        <div class="icon">
          <i class="fa fa-cart-plus"></i>
        </div>
        <?= Html::a(Yii::t('app', 'mas info')
                ." <i class='fa fa-arrow-circle-right'></i>", 
            $urlVentas, ['class' => 'small-box-footer', 'target'=>'_blank']) ?>
      </div>
    </div>        
</div>

  
<div class="box box-info">
    <div class="box-header with-border">
        <h4><?= Yii::t('app', 'ventas ultimos meses') ?></h4>
        <div class="box-tools pull-right">
            <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
            </button>
        </div> 
    </div>
    <div class="box-body" id="ventasUltMes">
      <div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>  
    </div>
</div>

<div class="box box-info">
    <div class="box-header with-border">
        <h4><?= Yii::t('app', 'compras ultimos meses') ?></h4>
        <div class="box-tools pull-right">
            <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
            </button>
        </div> 
    </div>
    <div class="box-body" id="comprasUltMes">
      <div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>  
    </div>  
</div>

<script>
    $(document).ready(function(){
        ventasUltMes();
        comprasUltMes();
        totalVentasMes();
        totalCompraMes();
        clienteMV();
        referenciaMV();
    });
    
    function totalVentasMes(){  
        $("#totalVentaMes").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['totalventasmes']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error total ventas')?>');                    
            },
            success: function(data) { 
                total = formatNumber(data.total);
                $('#totalVentaMes').html('$'+total);
            }
        });
    }
    
    function totalCompraMes(){  
        $("#totalCompraMes").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['totalcomprasmes']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error total compras')?>');                    
            },
            success: function(data) { 
                total = formatNumber(data.total);
                $('#totalCompraMes').html('$'+total);
            }
        });
    }
    
    function clienteMV(){ 
        $("#clienteMV").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['clientemayorventa']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error cliente mayor venta')?>');                    
            },
            success: function(data) { 
                total = formatNumber(data.total);
                $('#clienteMV').html('$'+total);
                str = data.nit+' - '+data.razon_social;
                strResult = str.substring(0,30);
                $('#nomCliente').html(strResult+'...');
            }
        });
    }
    
    function referenciaMV(){   
        $("#referenciaMV").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['referenciamayorventa']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error referencia mayor venta')?>');                    
            },
            success: function(data) { 
                total = formatNumber(data.total);
                $('#referenciaMV').html('$'+total);
                str = data.referencia+' - '+data.descripcion;
                strResult = str.substring(0,30);
                $('#nomReferencia').html(strResult+'...');
            }
        });
    }
    
    function ventasUltMes(){   
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['ventasultimosmeses']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            //dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error ventas ultimos meses')?>');                    
            },
            success: function(data) { 
                $('#ventasUltMes').replaceWith(data);
            }
        });
    }
    
    function comprasUltMes(){   
        proveedor = $('#proveedores-id').val();            
        $.ajax({url: '<?= Url::to(['comprasultimosmeses']) ?>',
            type: "post",
            data: {proveedor: proveedor},
            //dataType: 'json',
            error : function(){                
                //alert('<?= Yii::t('app', 'Error compras ultimos meses')?>');                    
            },
            success: function(data) { 
                $('#comprasUltMes').replaceWith(data);
            }
        });
    }
    
    function formatNumber(num) {
        return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,')
    }
    
</script>