<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */
/* @var $model \common\models\LoginForm */

$this->title = 'B2Bi';

$fieldOptions1 = [
    'options' => ['class' => 'form-group has-feedback'],
    'inputTemplate' => "{input}<i class='glyphicon glyphicon-user form-control-feedback'></i>"
];

$fieldOptions2 = [
    'options' => ['class' => 'form-group has-feedback'],
    'inputTemplate' => "{input}<i class='glyphicon glyphicon-lock form-control-feedback'></i>"
];
?>

<div class="login-box">
    <div class="login-logo">
        <?= \yii\helpers\Html::img('img/logo-b2bi.png', ['width'=>'200']) ?>        
    </div>
    <!-- /.login-logo -->
    <div class="box box-primary">
        <div class="box-header with-border">
            <h4 class="box-title" style="text-align: center">Ingresa tu usuario y contrase&ntilde;a para comenzar la sesi&oacute;n</h4>
        </div>
        <div class="box-body">
            <div class="login-box-body">
                <?php
                $form = ActiveForm::begin(['id' => 'login-form',
                            'enableClientValidation' => false]);
                ?>

                <?= $form->field($model, 'username', $fieldOptions1)
                    ->label(false)
                    ->textInput(['placeholder' => $model->getAttributeLabel('username')])
                ?>

                <?= $form->field($model, 'password', $fieldOptions2)
                    ->label(false)
                    ->passwordInput(['placeholder' => $model->getAttributeLabel('password')])
                ?>
                                
                <div class="row">
                    <div class="col-md-8">
                        <?= $form->field($model, 'rememberMe')->checkbox() ?>
                    </div>                    
                    <div class="col-md-4">
                        <?= Html::submitButton('Ingresar', 
                            ['class' => 'btn btn-primary btn-block btn-flat',
                            'name' => 'login-button'])
                        ?>
                    </div>                    
                </div>                
                <div class="form-group">
                    <p>
                        <u><?= Html::a(Yii::t('app', 'recuperar contrasena'), 
                            ['repass'], ['class' => 'lnk-repass']) ?></u>
                    </p>
                </div>
                <?php ActiveForm::end(); ?>
            </div>            
        </div>
    </div>    
</div><!-- /.login-box -->

