<?php

use yii\helpers\Html;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\UsrBranchOffice */
/* @var $form yii\widgets\ActiveForm */

$user = $model->isNewRecord ? '' : $model->id_user;
$provider = $model->isNewRecord ? '' : $model->name_provider;
$city = $model->isNewRecord ? '' : $model->name_city;

$branch_office = [];

if(!$model->isNewRecord){
    $branch_office = explode(',', $model->code_branch_office);
    $model->code_city = explode(',', $model->code_city);
}

?>

<div class="usrbranchoffice-form box box-primary">
    <div class="box-body">
        <br>
        <?php $form = ActiveForm::begin(['layout' => 'horizontal']); ?>

        <?php echo $form->field($model, 'code_provider')->widget(Select2::classname(), [
            //'data' => $providers,
            //'value' => $provider,
            'initValueText' => $model->name_provider, // set the initial display text
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT,
            'pluginOptions' => [
                'allowClear' => true,
                'minimumInputLength' => 3,
                'language' => 'es',
                'ajax' => [
                    'url' => Url::to(['listclients']),
                    'dataType' => 'json',
                    'data' => new JsExpression('function(params) { return {q:params.term}; }')
                ],
                'escapeMarkup' => new JsExpression('function (markup) { return markup; }'),
                'templateResult' => new JsExpression('function(data) { return data.text; }'),
                'templateSelection' => new JsExpression('function (data) { return data.text; }'),
            ],
        ])->label(Yii::t('app', 'Name Provider')); ?>

        <?php echo $form->field($model, 'code_branch_office')->widget(DepDrop::classname(), [
            'type' => DepDrop::TYPE_SELECT2,
            'data' => $branch_office,
            'select2Options'=>[
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'multiple' => true,
                    'initialize' => true,
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) {return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = [1];'
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'initialize' => true,
                'params' => ['usrbranchoffice-code_provider', 'usrbranchoffice-id'],
                'depends'=>['usrbranchoffice-code_provider'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Sucursales...',
                'url' => Url::to(['get-branches-office'])
            ]
        ])->label(Yii::t('app', 'Name Branches Office')); ?>

        <?php echo $form->field($model, 'code_city')->widget(Select2::classname(), [
            //'initValueText' => explode(',', $model->name_city),
            'data' => $cities,
            'options' => [
                'theme' => Select2::THEME_KRAJEE,
                'placeholder' => 'Seleccione...',
                'multiple' => true,
                //'initialize' => true,
                'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                'templateResult' => new JsExpression('function(data) {return data.text; }'),
                'templateSelection' => new JsExpression('function (data) { '
                    . 'tmpText = data.text;'
                    . 'text = [1];'
                    . 'return data.text; }'),
            ],
            'pluginOptions' => [
                'tags' => true,
                'tokenSeparators' => [',', ' '],
            ],
        ]); ?>

        <?php echo $form->field($model, 'id_user')->widget(Select2::classname(), [
            'data' => $users,
            'value' => $user,
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT
        ]); ?>

        <div style="height:2px">
            <?= $form->field($model, 'id')->hiddenInput()->label(false)->error(false) ?>
            <?= $form->field($model, 'name_provider')->hiddenInput()->label(false)->error(false) ?>
            <?= $form->field($model, 'name_branch_office')->hiddenInput()->label(false)->error(false) ?>
            <?= $form->field($model, 'name_city')->hiddenInput()->label(false)->error(false) ?>
        </div>
        <hr>
        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-primary' : 'btn btn-primary']) ?>
                <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
            </div>
        </div>
        <?php ActiveForm::end(); ?>

    </div>
</div>

<script type="text/javascript">
    $(document).ready(function () {
        if($("#usrbranchoffice-code_provider option:selected").text() != ''){
            $("#usrbranchoffice-name_provider").val($( "#usrbranchoffice-code_provider option:selected" ).text());
        }

        $("#usrbranchoffice-code_branch_office").change(function() {
            let select = [];

            $('#usrbranchoffice-code_branch_office :selected').each(function(index){
                let res = $(this).text().split("-");
                select.push(res);
            });

            if(select.length > 0){
                $("#usrbranchoffice-name_branch_office").val(select).text();
            }
        });

        $( "#usrbranchoffice-code_provider" ).change(function() {
            $("#usrbranchoffice-name_provider").val($( "#usrbranchoffice-code_provider option:selected" ).text());
        });

//        $( "#usrbranchoffice-code_city" ).change(function() {
//            $("#usrbranchoffice-name_city").val($( "#usrbranchoffice-code_city option:selected" ).text());
//        });
        
        $("#usrbranchoffice-code_city").change(function() {
            console.log('hola');
            let selectCity = [];

            $('#usrbranchoffice-code_city :selected').each(function(index){
                let resCity = $(this).text().split("-");
                selectCity.push(resCity);
            });

            if(selectCity.length > 0){
                $("#usrbranchoffice-name_city").val(selectCity).text();
            }
        });
        
    })
</script>
