<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\UsrBranchOfficeSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'UsrBranchOffice');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usrpdv-index box box-primary">
    <div class="box-body">
        <p>
            <?= Html::a(Yii::t('app', 'Create UsrBranchOffice'), ['create'], ['class' => 'btn btn-primary']) ?>
        </p>
        <div class="box-body">
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'options' => [ 'style' => 'table-layout:fixed;' ],
            'columns' => [
                [
                    'label' => Yii::t('app', 'Name Provider'),
                    'attribute'=>'name_provider',
                ],
                [
                    'attribute'=>'name_branch_office',
                    'value'=> function($model){
                        return str_replace(',', ' - ', $model->name_branch_office);
                    }
                ],
                'name_city',
                [
                    'label' => Yii::t('app', 'username'),
                    'attribute'=>'id_user',
                    'filter'=>$users,
                    'value'=>function($data){
                        return $data->user->username;
                    }
                ],

                ['class' => 'yii\grid\ActionColumn'],
            ],
        ]); ?>
        </div>
    </div>
</div>
