<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\UsrBranchOffice */

$this->title = $model->user->username.' - '.$model->name_provider;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'UsrBranchOffice'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usrbranchoffice-view box box-primary">
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </p>
    </div>
    <div class="box-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'code_provider',
            'name_provider',
            [
                'attribute'=>'code_branch_office',
                'value'=> function($model){
                    return str_replace(',', ' - ', $model->code_branch_office);
                }
            ],
            [
                'attribute'=>'name_branch_office',
                'value'=> function($model){
                    return str_replace(',', ' - ', $model->name_branch_office);
                }
            ],
            [
                'attribute'=>'name_city',
                'value'=> function($model){
                    return str_replace(',', ' - ', $model->name_city);
                }
            ],
            [
                'attribute'=>'id_user',
                'value'=> $model->user->nombre
            ]
        ],
    ]) ?>
    </div>
</div>
