<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;
use app\models\Proveedores;
use app\models\Distribuidores;
use yii\helpers\ArrayHelper;
use app\models\Usuarios;

/* @var $this yii\web\View */
/* @var $model app\models\Usuarios */
/* @var $form yii\widgets\ActiveForm */

$div_prov = 'none';
$div_dist = 'none';

if(!$model->isNewRecord){        
    
    if($model->tipo == Usuarios::PROVEEDOR){
        $div_prov = 'block';           
    }
    
    if($model->tipo == Usuarios::DISTRIBUIDOR){
        $div_dist = 'none';
    }    
}


?>

<div class="usuarios-form box box-primary">
    <div class="box-body">
        <br>
        <?php $form = ActiveForm::begin(['layout' => 'horizontal']); ?>

        <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'username')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'password_repeat')->passwordInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'email')->textInput(['maxlength' => true]) ?>

        <?= $form->field($model, 'activo')->dropDownList([ 'SI' => 'SI', 'NO' => 'NO',]) ?>        

        <?php if (\Yii::$app->user->identity->isSuperAdmin()) : ?>
        
        <?php
            $roles = \Yii::$app->authManager->getRoles();            
            $arrayRoles = \yii\helpers\ArrayHelper::map($roles, 'name', 'name');
            unset($arrayRoles[\app\models\Usuarios::SUPER_ADMIN]);            
            asort($arrayRoles);
            echo $form->field($model, 'tipo')->dropDownList($arrayRoles
                    , ['prompt' => "Seleccione..."]);
        ?>    
        
        <div id="div_proveedor" style="display: <?= $div_prov ?>">
        <?php 
            $proveedores = Proveedores::find()->all();
            $arrayProv = ArrayHelper::map($proveedores, 'id', 'razon_social');           
            echo $form->field($model, 'proveedor_id')->dropDownList($arrayProv
                    , ['prompt' => "Seleccione..."]);
        ?>
        </div>
        
        <div id="div_distribuidor" style="display: <?= $div_dist ?>">
        <?php 
            $distribuidores = Distribuidores::find()->all();
            $arrayDist = ArrayHelper::map($distribuidores, 'id', 'razon_social');           
            echo $form->field($model, 'distribuidor_id')->dropDownList($arrayDist
                    , ['prompt' => "Seleccione..."]);
        ?>
        </div>
            
        <?php endif; ?>
               
        <hr>
        <div class="form-group">
            <div class="col-lg-offset-1 col-lg-11">
                <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
                <?php if (\Yii::$app->user->identity->isSuperAdmin()) : ?>
                    <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
                <?php endif; ?>
            </div>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>

<script type="text/javascript">
    $('#usuarios-tipo').change(function () {
        var seleccion = $(this).val();        
        if(seleccion == '<?= Usuarios::DISTRIBUIDOR ?>'){
            $('#div_distribuidor').show();
            $('#div_proveedor').hide();
        }
        
        if(seleccion == '<?= Usuarios::PROVEEDOR ?>'){            
            $('#div_proveedor').show();
            $('#div_distribuidor').hide();
        }
    });
</script>