<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\UsuariosSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Usuarios');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usuarios-index box box-primary">
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Create Usuarios'), ['create'], ['class' => 'btn btn-primary']) ?>
        </p>
    </div>
    <div class="box-body">
        <?=
        GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'responsiveWrap' => false,
            'layout' => "{items}\n{summary}",
            'columns' => [
                'id',
                'nombre',
                'username',
                'email:email',                    
                'tipo',
                [
                    'attribute' => 'activo',
                    'format' => ['html'],
                    'value' => function($data){
                        return \app\components\Util::getActivo($data->activo);                           
                    }
                ],
                [
                    'attribute' => 'nomProveedor',
                    'value' => 'proveedor.razon_social'
                ],
                // 'created',
                // 'created_by',
                // 'modified',
                // 'modified_by',                
                ['class' => 'yii\grid\ActionColumn'],
            ],
        ]);
        ?>
    </div>        
</div>
