<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Usuarios */

$this->title = $model->nombre;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Usuarios'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usuarios-view box box-primary">    
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?php if (\Yii::$app->user->identity->isSuperAdmin()) :?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>            
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
            <?php endif; ?>
        </p>
    </div>    
    <div class="box-body">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'id',
                'nombre',
                'username',
                'password',
                'email:email',
//                [
//                    'attribute' => 'clientes',
//                    'format' => ['html'],
//                    'value' => isset($model->sede)? $model->sede->cliente->nombre: null,
//                ],
//                [
//                    'attribute' => 'sede_id',
//                    'format' => ['html'],
//                    'value' => isset($model->sede)? $model->sede->nombre: null,
//                ],
                [
                    'label' => 'Activo',
                    'format' => ['html'],
                    'value' => \app\components\Util::getActivo($model->activo),
                ],
                'tipo',
                'created',
                'created_by',
                'modified',
                'modified_by',  
                [
                    'attribute' => 'proveedor_id',
                    'format' => ['html'],
                    'value' => isset($model->proveedor->razon_social)?$model->proveedor->razon_social : null,
                ],
            ],
        ]) ?>
    </div>
</div>
